uses Dos,TedRadky,VenomGFX,Vnm_PCX,Vnm_GIF,Vnm_PNG,Vnm_WMF,
     {$IFDEF RELEASE}Vnm_JPG2{$ELSE}Vnm_JPG{$ENDIF},Smooth,FNfont2,wokna32,
     Editpole,Lacrt,vaznik,disk,Konfig,Clanky,RezKlav{,DPMIexcp};
{$INCLUDE defines.inc}

const
    MAX_KLAVES = 200;
    ALT_SHIFT = 1;   {pro kombinaci Alt-Shift si z prstu vycucam ASCII kod 1}
    CTRL_ALT_NAHORU  = 2;
    CTRL_ALT_DOLEVA  = 3;
    CTRL_ALT_DOPRAVA = 4;
    CTRL_ALT_DOLU    = 5;

    BLOCEK_CFG_OK        = 0;
    BLOCEK_CFG_CHYBI     = 1;
    BLOCEK_CFG_NESPRAVNY = 2;

    NH_NAHRAD        = 1;
    NH_PREPTEJ_SE    = 2;
    NH_ZMEN_VSE      = 4;

    VYSKA_HL_MENU = 21;
    B_OKRAJ       = 3;    {bocni okraj}
    H_OKRAJ       = 5;  {Kolik pixelu pod posledni radkou menu bude umisteno
                         editacni pole}

    KOD_SEZNAMU_KLAVESNIC = '@*@';
    POCET_PROHLIZENYCHRADKU_PRI_ASCII_DETEKCI = 2000;

    unicode_font:string[30]='unismall.ufn';
    non_unicode_font:string[30]=FN_FONT_VGA16;
    zadost_o_zavreni:longint = 0;
    zadost_o_otevreni:ansistring = '';
    mozno_sejmout_obrazovku:boolean = true;
    jsem_v_hlavnim_okne:boolean = true;
    globalne_posledni_hledany_retezec:string = '';
    prefix:longint = 0;

type
     PMojeEdipole = ^MojeEdipole;
     MojeEdipole = object(EditacniPole)
     info1:string;
     posledni_hledany_retezec:string;
     zobrazovat:boolean;
     Constructor Init(ix,iy,_sirka,_vyska:longint;iakt:boolean);
     Procedure Zobraz;
     Procedure BarevnaSyntaxe;
     Destructor Done;virtual;
     end;

     pedob = ^edob;
     edob = object
     ed:PMojeEdipole;
     ob:PVWOkno;
     Constructor Init(obrazek:boolean);
     Destructor Done;
     end;

     pklavesy = ^klavesy;
     klavesy = array[1..MAX_KLAVES] of record p,a,u:longint;c:boolean;end;

     Punifiltr = ^Tunifiltr;
     Tunifiltr = record
     t_velke_na_male:pointer; {tabulka pro prevod znaku na mala pismena}
     soubor,nazev:string;
     mapa:pklavesy;
     end;

     PASCIIkonv = ^TASCIIkonv;
     TASCIIkonv = record
     nazev:string;
     mapa:string[128];
     pocet:longint;
     end;

     PZnaktab = ^Znaktab;
     Znaktab = packed record
     znak:word;
     x1,y1,x2,y2:word;
     end;

     PBSeznam = ^TBSeznam;
     TBSeznam = object(TSeznam)
     Procedure RozbalSeznam;virtual;
     end;

var ed:PMojeEdipole;
    ob:PVWOkno;
    chybejici_konfigurace:PVaznik;
    edvaz:PVaznik;      {bude drzet objekt PEdob}
    moje_klavesnice,vidi_klavesnice,__vidi,__filt,__ascii:PVaznik;
    mimoradny_kod:byte;
    Aktualni_klavesnice:Punifiltr;
    listicka:TLista;
    tab_na_mezery:longint;
    Vyska_Soub_L:longint;
    Vyska_DL:longint;
    vb:PVybernicek;
    za_un,za_za:Zatrzitko;
    ob_zoom,ob_rp,ob_rm,ob_fh,ob_fv:Tlacitko;
    klin:TBSeznam;
    ss:PStrom;
    pracvw:PVirtualwindow;
    gl_popredi,gl_pozadi,zaklad,zvyraznovac:longint;
    obrazovy_filtr:longint;
    listovy_font:string[30];
    doplnky_desktopu:string;   { :-) }
    pref_klavesnice,pref_filtry,pref_asciifiltry:string;
    l_f:fn;
    hlasky:pdpole;
    moje_utf8_tbl:utf8conv;
    malsyst:string;
    posledni_adresar:string;
    globalni_rezim_hledani:byte;
    krok_v_nahradach:longint;
    globalni_filtr:pointer;
    globalni_rozlisuj:boolean;
    __barevna_syntaxe:longint;
    check_swap:longint;
    __test_nacteni:longint;
    screen_width,screen_height:longint;
    seznam_filtru,seznam_vidifiltru,seznam_asciifiltru,seznam_vidiasciifiltru:Pvaznik;
    _ex,_ey,_xr,_yr:longint;
    GlobalVirt:Virtualwindow;
    oldexitproc:pointer;
    __mmx,__simd:longint;
    __kbdmapping:string;
    __lng1,__lng2:string;
    _df,_bl:PKonfig;

{-------------------------------------------------------------------------}
Function NastartujEditacniPole(obrazek:boolean):PMojeEdipole;forward;
Procedure ZavriOkno_z_menu;forward;
Function ZavriOkno(p:PVaznik):byte;forward;
Procedure SejmiObrazovku;forward;
Function UniFiltr2string(p:pointer):string;forward;
Procedure MyEdZobrProc;forward;
Function MyEdProc(o:word):word;forward;
Procedure MyEdPmysProc(e:PMojeEdipole);forward;
Function MyOsetreniKlavesnice(o:word):string;forward;
Procedure lis_vybrani_z_listy(i:longint;p:Plista);forward;
Function lis_text_s_napovedou(p:pointer):string;forward;
Function MyPostupNahravani(r:real):boolean;forward;
{-------------------------------------------------------------------------}

Procedure ZapniGrafiku;
begin
Init_Graph(find_mode(screen_width,screen_height),ANY_ACCESS{LFB_ACCESS},BEST_FQ or 70);
FontAdr(EXEdir+'fonty\');  {Adresar s fonty}
FN_PCX_adresar:=EXEdir;
SetLastLine(vga.hoeheminus1);
Init_Mouse(vga);
MouseShow;
end;

Procedure VykresliPozadiProgramu;
begin
MouseHide;
Clr(vga,zaklad);
FN_ignore:=true;
print_fn(0,0,doplnky_desktopu,l_f);
MouseShow;
end;

Function UrcenyFont(s:string):string;
begin
s:=Convert_Up(s);
if s='<VGA16>' then s:=FN_FONT_VGA16 else
if s='<VGA16U>' then s:=FN_FONT_VGA16_U else
if s='<VGA14>' then s:=FN_FONT_VGA14 else
if s='<VGA8>' then s:=FN_FONT_VGA8;
UrcenyFont:=s;
end;

Function PrekladFontu(s:string):string;
begin
if s=FN_FONT_VGA16 then s:='<vga16>' else
if s=FN_FONT_VGA16_U then s:='<vga16u>' else
if s=FN_FONT_VGA14 then s:='<vga14>' else
if s=FN_FONT_VGA8 then s:='<vga8>';
PrekladFontu:=s;
end;

Constructor MojeEdipole.Init(ix,iy,_sirka,_vyska:longint;iakt:boolean);
var p:pointer;
begin
inherited Init(ix,iy,_sirka,_vyska,iakt);
posledni_hledany_retezec:='';
zobrazovat:=true;
Kill_VW(virt^);
virt:=@GlobalVirt;

ED_key_proc:=@MyEdProc;
ED_Zobr_proc:=@MyEdZobrProc;
ukaz_postup_nahravani:=@MyPostupNahravani;
p:=@MyEdPmysProc;move(p,ED_PMys_proc,4);
mimoradne_osetreni_klavesnice:=@MyOsetreniKlavesnice;
popredi:=gl_popredi;
ZmenBarvuPozadi(gl_pozadi);
hlavni_font:=non_unicode_font;
tab_na_mezery:=tab_na_mezery;
end;

Procedure MojeEdipole.Zobraz;
begin
if zobrazovat then inherited Zobraz;
end;

Procedure MojeEdiPole.BarevnaSyntaxe;
const bar_predtag='<BARVA=64000>';
      bar_zatag='<SB>';
      bar_vzorek='egi';

var v:PEdRadek;
    p:PVaznik;
    i,j,k,l:longint;
    bpl,bzl,bvl:longint;

    dd:string;

begin
bpl:=Length(bar_predtag);
bzl:=Length(bar_zatag);
bvl:=Length(bar_vzorek);
p:=radky^.dalsi;
k:=0;
while p<>nil do
   begin
   inc(k);
   v:=p^.vazba;
   i:=1;
   repeat
   dd:=v^.p;
   j:=pSearch(v^.p,v^.spp-1,bar_vzorek,i);
   if j<>0 then
      begin
      if unicode then k:=UniZnakZpet(v^.p,j-1) else k:=1;
      if unicode then l:=UniZnakVpred(v^.p,j+bvl-1) else l:=1;

      v^.VlozS(bar_zatag,j+bvl+l);
      v^.VlozS(bar_predtag,j-k);
      i:=j+bpl+bzl;
      end;
   until j=0;
   p:=p^.dalsi;
   end;
end;

Procedure TestNacteni;
{PROC? Proc verze 2.0.4 obcas udela, ze v^.spp=0 ?}
{Tenhle test by nemel byt vubec potreba}
{V kazdem pripade se provede jenom tehdy, je-li v BLOCEK.CFG nastaveno}
{ test_nacteni = 1 }
var v:PEdRadek;
    p:PVaznik;
    s:string;
begin
p:=ed^.radky^.dalsi;
while p<>nil do
   begin
   v:=p^.vazba;
   if v^.spp<1 then
      begin
      s:=v^.p;
      v^.spp:=PLength(v^.p)+1;
      beep;
      end;
   p:=p^.dalsi;
   end;
end;

Destructor MojeEdipole.Done;
begin
kpoz.hoehe:=100;
Kill_VW(kpoz);
EP_ZavriSoubor;
Dispose(radky,done);
end;

Procedure ZavedSystemovyFont;
var a:byte;
    s:string;
begin
a:=Nacti_FNSLR(listovy_font);
l_f:=fn_selector^[a].font;
s:=hlla('sys_font');
print_fn(0,0,hlla('sys_font'),fn_vga16);
malsyst:=hlla('sys_font_maly');
FN_syst_font:=FN_default;
NastavFont(FN_default);
end;

Function xReadKey_obsluha(b:byte):word;
{Presmerovava na sebe cele xReadKey}
var w:word;
    s:string;
begin
if mimoradny_kod<>0 then Exit(mimoradny_kod);
Asm
   mov AX,$0700 {cislo sluzby pro cteni klaves}
   int $21      {precteni klavesy - normalni Readkey}
   or AL,AL      {neco udelame s AL, ve kterem se vratil ten znak (tak, abychom ho nezmenili), tim se nastavi ZF}
   jnz @vratznak {takze kdyz to AL neni 0, skocime dal >> }
   int $21        {jestli jsme jeste tady, tak v AL byla 0, takze precteme dalsi znak (v AX porad jeste je $07)}
   mov AH,1       {do AH ulozime 1, aby bylo poznat, ze to byla specialni klavesa}
   jmp @konec     {a mame hotovo.}
   @vratznak:
   xor AH,AH     { >> vynulujeme AH, precteny znak zustane v AL a je vymalovano.}
   @konec:
   mov w,ax
end;
if (w=xAltF2) and mozno_sejmout_obrazovku then
   begin
   s:=FN_default;
   FN_default:=FN_syst_font;
   SejmiObrazovku;
   FN_default:=s;
   end;
xReadKey_obsluha:=w;
end;

Procedure MyExitProc;
begin
if ErrorAddr<>nil then
   begin
   Kill_Graph;
   VypniObsluhuKlavesnice;
   ExitProc:=@OldExitProc;
   end else ExitProc:=OldExitProc;
end;

function xKeyPressed_obsluha_AltShift(b:byte):boolean;
begin
mimoradny_kod:=0;
xKeyPressed_obsluha_AltShift:=true;
if (vsechny_klavesy[KEY_ALT] and vsechny_klavesy[KEY_SHIFT]) then
   mimoradny_kod:=ALT_SHIFT else

if (vsechny_klavesy[KEY_CTRL] and vsechny_klavesy[KEY_ALT] and vsechny_klavesy[KEY_G_CURSOR_UP]) then
   mimoradny_kod:=CTRL_ALT_NAHORU else

if (vsechny_klavesy[KEY_CTRL] and vsechny_klavesy[KEY_ALT] and vsechny_klavesy[KEY_G_CURSOR_LEFT]) then
   mimoradny_kod:=CTRL_ALT_DOLEVA else

if (vsechny_klavesy[KEY_CTRL] and vsechny_klavesy[KEY_ALT] and vsechny_klavesy[KEY_G_CURSOR_RIGHT]) then
   mimoradny_kod:=CTRL_ALT_DOPRAVA else

if (vsechny_klavesy[KEY_CTRL] and vsechny_klavesy[KEY_ALT] and vsechny_klavesy[KEY_G_CURSOR_DOWN]) then
   mimoradny_kod:=CTRL_ALT_DOLU else

xKeyPressed_obsluha_AltShift:=LKeyPressed;
end;

Procedure NahrajPrevodniTabulku(q:pUniFiltr;s:string);
{Definice prevodni tabulky vypada takto:}
{[   ]}
{proste vzdy dvojice pismen: velka forma a za nim mala}
var a,b,c:byte;
    d:char;
begin
if q^.t_velke_na_male=@DOS_velke_na_male then
   begin
   GetMem(q^.t_velke_na_male,256);
   Move(DOS_male_na_velke,q^.t_velke_na_male^,256);
   end;
s:=SkipAllSpaces(s);
b:=Length(s);
a:=2;
repeat
c:=byte(s[a]);
d:=s[a+1];
if (c=93{']'}) or (d=']') then Break;
pASCIIprevodni_tabulka(q^.t_velke_na_male)^[c]:=d;
inc(a,2);
until a>b;
end;

Procedure ZpracujMapyKlavesnic(var p:pointer);
var q:PUniFiltr;
    v:PKlavesy;
    uni,s:string;
    utf:utf8conv;
    kf:TKonfig;
    pp:PVaznik;
    vv:PKFpolozka;
    a,i,b:longint;
    caps:boolean;
begin
q:=p;
New(v);
q^.mapa:=v;
caps:=false;
kf.init;
kf.NactiKonfiguraci(EXEdir+'key_tbl\'+q^.soubor);
pp:=kf.cfg^.dalsi^.dalsi;
vv:=pp^.vazba;
uni:=vv^.k^;         {defaultni mapovani unicode znaku}
NahrajUTF8tabulku(EXEdir+'key_tbl\'+uni,utf);
q^.t_velke_na_male:=@DOS_velke_na_male;
i:=0;
pp:=pp^.dalsi;
while pp<>nil do
   begin
   vv:=pp^.vazba;
   if vv^.z=nil then  {toto neni radek s ROVNA SE}
      begin
      s:=vv^.k^;
      if s[1]='-' then caps:=false else
      if s[1]='+' then caps:=true else
      if s[1]='[' then NahrajPrevodniTabulku(q,s);
      end
   else begin
   inc(i);
   v^[i].p:=MyVal(vv^.z^);
   v^[i].c:=caps;        {je tato klavesa ovlivnitelna CapsLockem?}
   a:=Pos('(',vv^.c^);   {je explicitne definovan unicode znak?}
   if a=0 then
      begin         {ne}
      v^[i].a:=MyVal(vv^.c^);               {priradim ASCII hodnotu}
      v^[i].u:=PrelozZnak(v^[i].a,utf);    {a z TBL souboru vytahnu UTF ekvivalent}
      end
      else begin    {ano}
      s:=s;
      v^[i].a:=MyVal(Copy(vv^.c^,1,a-1));   {to pred zavorkou je ASCII hodnota}
      b:=Pos(')',vv^.c^);
      v^[i].u:=MyVal(Mid(vv^.c^,a+1,b-1));    {a to v zavorce je UTF}
      end;
   end;
   pp:=pp^.dalsi;
   end;
kf.Done;
end;

Procedure KillPuniFiltr(var p:pointer);
var v:pUniFiltr;
begin
v:=p;
Dispose(v);
end;

Procedure NactiDuleziteSoubory(co:string;var kam:Pvaznik);
var p:Pvaznik;
    u:UkNaTSoubor;
    v:Punifiltr;
    t:text;
    s,m:string;
begin
m:=StripPath(co);
SeznamSouboru(kam,co);
p:=kam^.dalsi;
while p<>nil do
   begin
   u:=p^.vazba;
   New(v);
   v^.soubor:=Convert_Up(u^.jmeno^+'.'+u^.koncovka^);
   Assign(t,m+v^.soubor);
   Reset(t);
   readln(t,s);
   Close(t);
   v^.nazev:=s;
   Smaz_VS_S(u);
   p^.vazba:=v;
   p:=p^.dalsi;
   end;
end;

Procedure Pstring_na_unifiltr(pp:PVaznik;var vse,vyb:PVaznik);
var p,q:PVaznik;
    j:Pstring;
    v:PUnifiltr;
begin
p:=pp^.dalsi;
while p<>nil do
   begin
   j:=p^.vazba;
   q:=vse^.dalsi;
   while q<>nil do
      begin
      v:=q^.vazba;
      if v^.soubor=j^ then
         begin
         vyb^.InitNext(q^.vazba);
         Break;
         end;
      q:=q^.dalsi;
      end;
   p:=p^.dalsi;
   end;
end;


function PripravViditelneFiltry(vstup,seznam:PVaznik):PVaznik;
var v:PUnifiltr;
    p:PVaznik;
begin
p:=New(PVaznik,Init(nil,nil));
PString_na_unifiltr(vstup,seznam,p);
new(v);
v^.soubor:=KOD_SEZNAMU_KLAVESNIC;
v^.nazev:=hlla('plnyseznam');
p^.InitNext(v);
PripravViditelneFiltry:=p;
end;

Procedure NactiFiltry;
begin
NactiDuleziteSoubory(EXEdir+'key_tbl\*.tbl',seznam_filtru);
NactiDuleziteSoubory(EXEdir+'key_tbl\*.a8t',seznam_asciifiltru);
seznam_vidifiltru:=PripravViditelneFiltry(__filt,seznam_filtru);
seznam_vidiasciifiltru:=PripravViditelneFiltry(__ascii,seznam_asciifiltru);
SmazVaznikPStringu(__filt);
SmazVaznikPStringu(__ascii);
end;

Procedure PripravViditelneKlavesnice;
var p,q:PVaznik;
    v:Punifiltr;
begin
vidi_klavesnice:=New(PVaznik,Init(nil,nil));
vidi_klavesnice^.InitNext(moje_klavesnice^.dalsi^.vazba); {polozka DOS}
PString_na_unifiltr(__vidi,moje_klavesnice^.dalsi,vidi_klavesnice);
new(v);
v^.soubor:=KOD_SEZNAMU_KLAVESNIC;
v^.nazev:=hlla('plnyseznam');
vidi_klavesnice^.InitNext(v);
end;

Procedure NactiMapyKlavesnic;
var p:PVaznik;
    v:Punifiltr;
begin
NactiDuleziteSoubory(EXEdir+'key_tbl\*.ktb',moje_klavesnice);
new(v);
v^.soubor:='';
v^.nazev:='<FONT=latin216.ch>DOS<SF>';
v^.t_velke_na_male:=@DOS_velke_na_male;
p:=New(Pvaznik,Init(nil,nil));
p^.vazba:=v;
moje_klavesnice^.Insert(p);
moje_klavesnice^.dalsi^.For_Each(@ZpracujMapyKlavesnic);

{moje_klavesnice^.Insert(p);}
PripravViditelneKlavesnice;
SmazVaznikPStringu(__vidi);
end;

Procedure KFpridej(s:string);
var p:PVaznik;
    v:PKFpolozka;
    m:string;
begin
p:=_df^.Vrat_ID_polozky(s);
v:=p^.vazba;
if v^.k=nil then m:='' else m:=v^.k^;
_bl^.DefinujPolozku(v^.z^,v^.c^,m);
chybejici_konfigurace^.InitNext(NaPString(s));
end;

Procedure KFnacti(var prom:string;s:string;hl:boolean);
var i:string;
    p:PVaznik;
    v:PKFpolozka;
    kf:PKonfig;
begin
if hl then kf:=_df else kf:=_bl;
if hl then i:=kf^.NactiPolozku(s,'')
   else begin
   i:=kf^.NactiPolozku(s,' ');
   if i=' ' then
      begin
      i:=prom;
      KFpridej(s);
      end;
   end;
prom:=i;
end;

Procedure KFnacti(var prom:longint;s:string;hl:boolean);
var i:longint;
    m:string;
    p:PVaznik;
    v:PKFpolozka;
    kf:PKonfig;
begin
if hl then kf:=_df else kf:=_bl;
if hl then i:=MyVal(kf^.NactiPolozku(s,''))
   else begin
   m:=kf^.NactiPolozku(s,' ');
   if m=' ' then
      begin
      i:=prom;
      KFpridej(s);
      end else i:=MyVal(m);
   end;
prom:=i;
end;


Procedure NactiZeSouboru(hl:boolean);
begin
Kfnacti(screen_width,'screen_width',hl);
Kfnacti(screen_height,'screen_height',hl);
Kfnacti(tab_na_mezery,'tab_na_mezery',hl);
Kfnacti(gl_popredi,'popredi',hl);
Kfnacti(gl_pozadi,'pozadi',hl);
Kfnacti(zaklad,'zaklad',hl);
Kfnacti(doplnky_desktopu,'doplnky_desktopu',hl);
Kfnacti(listovy_font,'listovy_font',hl);
Kfnacti(non_unicode_font,'non_unicode_font',hl);
Kfnacti(unicode_font,'unicode_font',hl);
Kfnacti(zvyraznovac,'zvyraznovac',hl);
Kfnacti(obrazovy_filtr,'imgfilter',hl);
Kfnacti(krok_v_nahradach,'krok_v_nahradach',hl);
Kfnacti(check_swap,'zkontroluj_swap',hl);
Kfnacti(__mmx,'use_mmx',hl);
Kfnacti(__simd,'use_simd',hl);
Kfnacti(__lng1,'texty1',hl);           {wokna32}
Kfnacti(__lng2,'texty2',hl);           {blocek}
Kfnacti(__kbdmapping,'keyboard_mapping',hl);
Kfnacti(__barevna_syntaxe,'barevna_syntaxe',hl);
Kfnacti(__test_nacteni,'test_nacteni',hl);
Kfnacti(pref_klavesnice,'pref_klavesnice',hl);
Kfnacti(pref_filtry,'pref_filtry',hl);
Kfnacti(pref_asciifiltry,'pref_asciifiltry',hl);
end;

Procedure Nahraj_soubory_s_hlaskami;
var nlspath,lang:string;
    s:string;
begin
nlspath:=GetEnv('NLSPATH');
if nlspath<>'' then
   if nlspath[Length(nlspath)]<>'\' then nlspath:=nlspath+'\';
lang:=GetEnv('LANG');

if (nlspath<>'') and (lang<>'') then
   begin
   s:=nlspath+'blocek1.'+lang;
   if ExistFile(s) then __lng1:=s;
   s:=nlspath+'blocek2.'+lang;
   if ExistFile(s) then __lng2:=s;
   end;

if not ExistFile(__lng1) then
   begin writeln('Chyb soubor ',__lng1,' !');Halt(2);end;
if not ExistFile(__lng2) then
   begin writeln('Chyb soubor ',__lng2,' !');Halt(2);end;
NactiHlasky_ze_souboru(__lng1);   {wokna32}
hlasky:=Nacti_Data(__lng2);        {blocek}
vaznik_s_hlaskami:=hlasky;
end;

Procedure NPKF_jadro(co:string;var kam:Pvaznik);
var p,r:longint;
    s:string;
begin
co:=SkipAllSpaces(co);
if co='' then Exit;
repeat
p:=Pos(',',co);
if p=0 then r:=Length(co)+1 else r:=p;
s:=Convert_Up(Copy(co,1,r-1));
delete(co,1,r);
kam^.InitNext(NaPstring(s));
until p=0;
end;

Procedure NactiPreferovaneKlavesnice_a_filtry;
begin
__vidi:=New(PVaznik,Init(nil,nil));
__filt:=New(PVaznik,Init(nil,nil));
__ascii:=New(PVaznik,Init(nil,nil));
NPKF_jadro(pref_klavesnice,__vidi);
NPKF_jadro(pref_filtry,__filt);
NPKF_jadro(pref_asciifiltry,__ascii);
end;

Function NactiKonfiguraci:byte;
var s:string;
begin
if not ExistFile(EXEdir+'default.cfg') then
   begin writeln('Chyb soubor '+EXEdir+'DEFAULT.CFG !');Halt(2);end;
_bl:=New(PKonfig,init);
_df:=New(PKonfig,init);
_df^.NactiKonfiguraci(EXEdir+'default.cfg');
NactiZeSouboru(true);

if not ExistFile(EXEdir+'blocek.cfg') then
   begin
   CopyFile(EXEdir+'default.cfg',EXEdir+'blocek.cfg');
   NactiKonfiguraci:=BLOCEK_CFG_CHYBI;
   end
   else begin
   _bl^.NactiKonfiguraci(EXEdir+'blocek.cfg');
   if _bl^.NactiPolozku('verze_konfiguratoru',' ')<>'2' then
      begin
      CopyFile(EXEdir+'default.cfg',EXEdir+'blocek.cfg');
      NactiKonfiguraci:=BLOCEK_CFG_NESPRAVNY;
      end
      else begin
      NactiZeSouboru(false);
      NactiKonfiguraci:=BLOCEK_CFG_OK;
      if chybejici_konfigurace^.dalsi<>nil then _bl^.Zapis(EXEdir+'blocek.cfg');
      end;
   end;
__lng1:=EXEdir+__lng1;
__lng2:=EXEdir+__lng2;
listovy_font:=UrcenyFont(listovy_font);
non_unicode_font:=UrcenyFont(non_unicode_font);

Nahraj_soubory_s_hlaskami;
if __mmx<>1 then cpu_info_mmx:=false;
if __simd<>1 then cpu_info_emmx:=false;
__kbdmapping:=EXEdir+'key_tbl\'+__kbdmapping;
NactiPreferovaneKlavesnice_a_filtry;
NahrajUtf8Tabulku(__kbdmapping,moje_utf8_tbl);
NactiFiltry;
NactiMapyKlavesnic;
Aktualni_klavesnice:=moje_klavesnice^.dalsi^.vazba;
Dispose(_df,Done);
Dispose(_bl,DOne);
GetDir(0,posledni_adresar);
if length(posledni_adresar)<>3 then
   posledni_adresar:=FExpand(posledni_adresar)+'\';
end;

Procedure TBSeznam.RozbalSeznam;
var v:PUnifiltr;
    k2:TSeznam;
    b:boolean;
    n:PVaznik;
begin
n:=hodnota;
repeat
b:=true;
inherited RozbalSeznam;
v:=klin.hodnota^.vazba;
if (v^.soubor=KOD_SEZNAMU_KLAVESNIC) then
   if (bylo_vybrano=true) then
      begin
      k2.init(vga.breite-130,1,128,450,moje_klavesnice,moje_klavesnice^.dalsi,@UniFiltr2string);
      k2.RozbalSeznam;
      if k2.bylo_vybrano=false then b:=false
         else begin
         hodnota:=k2.hodnota;
         end;
      k2.Done;
      if b then Zobraz;
      end
      else begin
      hodnota:=n;
      Zobraz;
      end;
until B;
end;


Function ListboxOknoPlus(x,y,sirka,vyska:longint;popis:string;vse,vyb:PVaznik;proc:Point2StrFunc):Pvaznik;
var p:PVaznik;
    v:Punifiltr;
    s:string;
    i,j:longint;
begin
i:=Rychlavyskaradky(popis);
p:=vyb^.dalsi;
while p<>nil do
   begin
   s:=proc(p^.vazba);
   inc(i,RychlaVyskaRadky(s)+1);
   p:=p^.dalsi;
   end;
inc(i,2);
if i>vyska then i:=vyska;
repeat
p:=ListboxOkno(x,y,sirka,i,popis,vyb,proc);
if p=nil then Exit(nil);
v:=p^.vazba;
if v^.soubor=KOD_SEZNAMU_KLAVESNIC then
   p:=ListboxOkno(x,y,sirka,vyska,popis,vse,proc);
until p<>nil;
ListboxOknoPlus:=p;
end;

Procedure DefiniceMenu;
begin
ss:=StromDef(
       {v1}Vetev(VytvorPolozku(hlla('m1'),'',1,true),
                 (
                   UzelS(VytvorPolozku(hlla('m11'),'',11,true),
                   UzelS(VytvorPolozku(hlla('m12'),'',12,true),
                   UzelS(VytvorPolozku(hlla('m13'),'',13,true),
                   UzelS(VytvorPolozku(hlla('m16'),'',16,true),
                   UzelS(VytvorPolozku(hlla('m14'),'',14,true),
                   UzelS(VytvorPolozku(hlla('m15'),'',15,true),nil))))))
                 ),
       {s1}  SvazejS(
       {v2}Vetev(VytvorPolozku(hlla('m4'),'',4,true),
                 (
                   UzelS(VytvorPolozku(hlla('m41'),'',41,true),
                   UzelS(VytvorPolozku(hlla('m42'),'',42,true),
                   UzelS(VytvorPolozku(hlla('m48'),'',48,true),
                   UzelS(VytvorPolozku(hlla('m43'),hlla('m43_pomoc'),43,true),
                   UzelS(VytvorPolozku(hlla('m44'),'',44,true),
                   UzelS(VytvorPolozku(hlla('m45'),'',45,true),
                   UzelS(VytvorPolozku(hlla('m46'),'',46,true),
                   UzelS(VytvorPolozku(hlla('m47'),'',47,true),nil))))))))
                 ),
       {s2}  SvazejS(
       {v3}Vetev(VytvorPolozku(hlla('m2'),'',2,true),
                 (
                   UzelS(VytvorPolozku(hlla('m21'),'',21,true),
                   UzelS(VytvorPolozku(hlla('m22'),'',22,true),
                   UzelS(VytvorPolozku(hlla('m23'),'',23,true),
                   UzelS(VytvorPolozku(hlla('m24'),'',24,true),
                   UzelS(VytvorPolozku(hlla('m25'),'',25,true),
                   UzelS(VytvorPolozku(hlla('m26'),'',26,true),
                   UzelS(VytvorPolozku(hlla('m27'),'',27,true),
                   UzelS(VytvorPolozku(hlla('m29'),'',29,true),
                   UzelS(VytvorPolozku(hlla('m28'),'',28,true),nil)))))))))
                 ),
       {s3}  SvazejS(
           Vetev(VytvorPolozku(hlla('m3'),'',3,true),
                 (
                   UzelS(VytvorPolozku(hlla('m31'),'',31,true),
                   UzelS(VytvorPolozku(hlla('m32'),'',32,true),
                   UzelS(VytvorPolozku(hlla('m33'),'',33,true),nil)))
                 ),nil
           )
      {/s3})
      {/v3})
      {/s2})
      {/v2})
      {/s1})
      {/v1})
 {stromdef});
vb:=New(PVybernicek,Init(0,0,vbVEDLESEBE+vbZOBRAZ+vbROZTAHNI,ss));

{jeste sem umistim indikator klavesnice}
klin.init(vga.breite-130,1,128,450,vidi_klavesnice,vidi_klavesnice^.dalsi,@UniFiltr2string);
end;

Procedure IndikatorKlavesnice;
begin
klin.zobraz;
end;

Procedure SpocitejZachytneBody;
begin
_ex:=B_OKRAJ;
_ey:={VYSKA_HL_MENU+Vyska_DL+Vyska_Soub_L}listicka.y+listicka.vyska+H_OKRAJ;
_xr:=vga.breite-_ex-_ex;
_yr:=vga.hoehe-_ey-3;
end;

Procedure VykresliMenu;
begin
NastavFont(FN_syst_font);
Bar(vga,0,0,vga.breiteminus1,VYSKA_HL_MENU-1,vga2word(7));
vb^.Zobraz;
vb^.dosah_kontroly:=vga.breite-400;
IndikatorKlavesnice;
end;

Procedure NakresliZatrzitko;
begin
if ed=nil then za_un.hodnota:=false else za_un.hodnota:=ed^.unicode;
if ed<>nil then za_za.hodnota:=ed^.zalamuj;
za_un.zobraz;
za_za.zobraz;
end;

Procedure InfoOobrazku(y:longint);
begin
Print_FN(5,y,'<BARVA=65535>'+mystr(ob^.zdroj.breite)+'x'+mystr(ob^.zdroj.hoehe)+'<SB>',fn_vga14);
ob_zoom.zobraz;
ob_rp.zobraz;
ob_rm.zobraz;
ob_fh.zobraz;
ob_fv.zobraz;
end;

Procedure VykresliDolniListu;
var y,v:longint;
begin
y:=VYSKA_HL_MENU;
_Box(0,y,vga.breiteminus1,y+Vyska_DL-1,mlhbarva,mpdbarva,mvbarva);

if ob=nil then
   begin
   NakresliZatrzitko;
   if ed<>nil then MyEdZobrProc;
   end
   else begin
   InfoOobrazku(y+Vyska_DL-1);
   end;
end;

Procedure VykresliPracoviste;
begin
VykresliPozadiProgramu;
VykresliMenu;
VykresliDolniListu;
listicka.Zobraz;
end;

Procedure UkonciProgram;
begin
if (ed=nil) or anoneokno(hlla('opravdu_konec')) then
   begin
   VypniObsluhuKlavesnice;
   Kill_Mouse;
   Kill_Graph;
   Halt(0);
   end;
end;

Procedure DOS_skok;
var v:VirtualWindow;
begin
MouseHide;
Init_VW(v,vga.breite,vga.hoehe,false);
Flip_VW(vga,v);
Kill_Mouse;
VypniObsluhuKlavesnice;
Kill_Graph;
Exec(GetEnv('COMSPEC'),'');
{videoprava:=false;}
ZapniGrafiku;
Mousehide;
Flip_VW(v,vga);
Kill_VW(v);
MouseShow;
ZapniObsluhuKlavesnice(KL_S_BIOSEM);
end;

Procedure Napoveda;
begin
OKokno(hlla('napoveda'),hllp(hlasky,'text_napovedy'));
end;

Procedure NactiDoListy;
var i:longint;
begin
i:=edvaz^.PocetPrvku;
listicka.zadane:=i;
listicka.NatahniPrvky(edvaz);
if listicka.dolut.neviditelny=false then
   begin
   inc(listicka.prvni);
   listicka.PridejPosouvatka;
   listicka.zobraz;
   end;
end;

Procedure NovySoubor;
begin
ed:=NastartujEditacniPole(false);
ob:=nil;
ed^.NovySoubor;
ed^.info1:=hlla('bezejmenny');
ed^.zobraz;
NactiDoListy;
end;

Function Uz_ho_tu_mame(s:string):boolean;
var p:Pvaznik;
    v:Pedob;
begin
s:=Convert_UP(s);
p:=Edvaz^.dalsi;
while p<>nil do
   begin
   v:=p^.vazba;
   if v^.ed<>nil then {misto ED tam totiz muze byt OB}
      if Convert_UP(v^.ed^.info1)=s then Exit(true);
   p:=p^.dalsi;
   end;
Uz_ho_tu_mame:=false;
end;

Function List_ret1(p:pointer):string;
var v:PEdob;
    s,t:string;

begin
v:=p;
if v^.ed=nil then
   begin
   s:=v^.ob^.info1;
   s:=StripName(s)+StripExt(s);
   end
   else begin
   s:=v^.ed^.info1;
   s:=StripName(s)+StripExt(s);
   end;
List_ret1:=s;
end;

Procedure UkazPocetZmen(s:string);
var v:virtualwindow;
    b:boolean;
    x,y,i,j,sirka,vyska:longint;
    e:PEdRadek;
    p,q:PVaznik;
begin
if s='' then
   begin
   MouseHide;
   if pracvw<>nil then
      begin
      PutSprite(vga,pracvw^,x,y);
      kill_vw(pracvw^);
      dispose(pracvw);
      pracvw:=nil;
      end;
   MouseShow;
   Exit;
   end;
p:=New(PVaznik,Init(nil,nil));
ZjistiRozmeryTextu(s,sirka,vyska,p);
i:=sirka;
j:=vyska;
inc(sirka,30);
inc(vyska,20);
if sirka<170 then sirka:=170;
if vyska<70 then vyska:=70;

Init_VW(v,sirka,vyska,false);
Clr(v,44414);
Rectangle(v,0,0,v.breiteminus1,v.hoeheminus1,51200);


SetBasicLine(v.hoehe div 2-j div 2);
NastavVystup(v);
q:=p^.dalsi;
while q<>nil do
   begin
   e:=q^.vazba;
   Print_FN(v.breite div 2-i div 2,AUTO_LINE,e^.p,e^.spp-1,l_f);
   q:=q^.dalsi;
   end;
NastavVystup(vga);
SmazVaznikPEdRadku(p);
x:=ZeStreduX(NA_STRED,v.breite);
y:=ZeStreduY(NA_STRED,v.hoehe);
b:=PrunikMysi(x,y,x+v.breiteminus1,y+v.hoehe-1);
if B then MouseHide;
if pracvw=nil then
   begin
   New(pracvw);
   Init_VW(pracvw^,sirka,vyska,false);
   GetSprite(vga,pracvw^,x,y);
   end;
PutSprite(vga,v,x,y);
if B then MouseShow;
Kill_VW(v);
end;

Procedure ZalozZatrzitko;
var hv:boolean;
    os:string;
begin
hv:=hned_vykresluj;
hned_vykresluj:=false;
os:=fn_default;
nastavfont(malsyst);
za_un.init(4,VYSKA_HL_MENU,hlla('unicode'),hlla('unicode_varovani'),false);
za_za.init(140,VYSKA_HL_MENU,hlla('zalamovani'),'',false);
ob_zoom.init(100,VYSKA_HL_MENU+2,hlla('zoom'),hlla('zoom_info'),100,0);

ob_rp.init(220,VYSKA_HL_MENU+2,hlla('plus90'),hlla('plus90_info'),50,0);
ob_rm.init(280,VYSKA_HL_MENU+2,hlla('minus90'),hlla('minus90_info'),50,0);

ob_fh.init(340,VYSKA_HL_MENU+2,hlla('fliphorz'),hlla('fliphorz_info'),60,0);
ob_fv.init(410,VYSKA_HL_MENU+2,hlla('flipvert'),hlla('flipvert_info'),60,0);
Vyska_DL:=Vyska_FN(AktualniFont)+5;

listicka.init(0,VYSKA_HL_MENU+VYSKA_DL,vga.breite,VYSKA_DL,105,5,@List_ret1,edvaz);
listicka.Lis_akce_pri_zadani:=@lis_vybrani_z_listy;
listicka.Lis_dej_retezec2:=@lis_text_s_napovedou;

nastavfont(os);

hned_vykresluj:=hv;
end;

Procedure VarovneOkno;
begin
OKokno(hlla('info'),hlla('tento_soubor_uz_jednou_mame'));
end;

Function ObrazovyValidator(s:string;var obr:virtualwindow):boolean;
{rovnez nastavi promennou Posledni_adresar}
var b:byte;
    c:boolean;
    cesta,jmeno,koncovka:string;

begin
FSplit(s,cesta,jmeno,koncovka);
koncovka:=Convert_UP(koncovka);
posledni_adresar:=cesta;
c:=true;
if koncovka='.BMP' then b:=Load_BMP(s,obr) else
if koncovka='.PCX' then b:=Load_PCX(s,obr) else
if koncovka='.GIF' then b:=Load_GIF(s,obr) else
if koncovka='.PNG' then b:=Load_PNG(s,obr) else
if koncovka='.JPG' then b:=Load_JPG(s,obr) else
if koncovka='.WMF' then
   begin
   {WMF je vektorovy format, proto ho musim zpracovat trosku jinak}
   Init_VW(obr,_xr-16,_yr-16,false);
   Clr(obr,65535);             {jako barvu pozadi dam bilou}
   b:=Load_WMF(s,obr);
   end
   else c:=false;
if C and (b<>0) then
   OKokno(hlla('chyba'),hlla('nejde_o_obrazek'));
ObrazovyValidator:=c and (b=0);
end;

Procedure NastartujObrazek(s:string;var obr:virtualwindow);
var e:Pedob;
    h:PVWOkno;
    t:string;
    data:VirtualWindow;
begin
e:=New(PEdob,Init(true));
edvaz^.InitNext(e);
h:=New(PVWOkno,Init(_ex,_ey,_xr,_yr,obr,true,true));
h^.info1:=s;
h^.ob_my_key_proc:=@MyEdProc;
e^.ob:=h;
ob:=h;
end;

Procedure OtevriSoubor(s:string);
var r:real;
    obr:virtualwindow;
    b:byte;
begin
if s='' then
   s:=VyberSouborOkno(hlla('vyber_soubor'),posledni_adresar+'*.*',
      'txt|doc|1st|bmp||jpg||gif||png||pcx||wmf|',350,VSNORMAL);
if s<>'' then
   begin
   ob:=nil;
   if ObrazovyValidator(s,obr) then {rovnez nastavi Posledni_adresar}
      begin
      NastartujObrazek(s,obr);
      VykreslidolniListu;
      NactidoListy;
      ob^.Zobraz;
      ed:=nil;
      Exit;
      end;
   if Uz_ho_tu_mame(s) then VarovneOkno;
   {if ed<>nil then ed^.ZhasniKurzor;}
   ed:=NastartujEditacniPole(false);
   ed^.hlavni_font:=non_unicode_font;
   b:=ed^.NactiSoubor(s);

   if b=edna_OK then
      begin
      if ed^.prac1=0 then r:=0 else r:=ed^.prac2/ed^.prac1;
      if r>0.9 then
         begin
         ed^.unicode:=true;
         ed^.hlavni_font:=unicode_font;
         ed^.NactiSoubor(s);            {znovunacteni - tentokrat v unicode}
         end;

      if __test_nacteni=1 then TestNacteni;    {grr...}
      if __barevna_syntaxe=1 then ed^.BarevnaSyntaxe;

      ed^.info1:=s;
      ed^.Zobraz;
      VykreslidolniListu;
      NactiDoListy;
      end
      else begin
      ed^.info1:=hlla('bezejmenny');
      ed^.zobraz;
      NactiDoListy;
      end;
   end;
end;

Procedure UlozSoubor(x:string);
var t:Souborovy_Dialog;
    s:string;
begin
if ed=nil then Exit;
if x='' then
   begin
   t.Init(hlla('jak_to_ulozit'),455,ed^.info1);
   t.Zobraz;
   if t.Bylo_cancel then begin t.Done;Exit;end;
   s:=t.hodnota;
   t.Done;
   if (Convert_up(ed^.info1)<>Convert_Up(s)) and ExistFile(s) then
      if not anoneokno(hlla('soubor_existuje_prepsat')) then Exit;
   end else s:=x;
if not ed^.UlozSoubor(s)
   then OKokno(hlla('chyba'),hlla('soubor_nebyl_ulozen'))
   else ed^.info1:=s;
if x='' then listicka.NatahniPrvky(edvaz);
end;

Procedure ZmenBarvuZakladu;
begin
zaklad:=VyberHiColorBarvuOkno(hlla('vyber_barvu_zakladu'),123);
VykresliPracoviste;
if ed<>nil then
   begin
   listicka.NatahniPrvky(edvaz);
   ed^.Zobraz;
   end;
end;

Procedure VyberFont;
var s:string;
begin
s:=VyberSouborOkno(hlla('vyber_soubor'),exedir+'fonty\*.*','FN|CH|VGA',350,0);
if s='' then Exit;
s:=convert_up(StripName(s)+StripExt(s));
if s='VGA8X16.VGA' then non_unicode_font:=FN_FONT_VGA16 else
if s='VGA8X16U.VGA' then non_unicode_font:=FN_FONT_VGA16_U else
if s='VGA8X14.VGA' then non_unicode_font:=FN_FONT_VGA14 else
if s='VGA8X08.VGA' then non_unicode_font:=FN_FONT_VGA8 else
   non_unicode_font:=s;
if ed<>nil then ed^.ZmenFont(non_unicode_font);
end;

Function VypisPreferovanePol(p:Pvaznik):string;
var q:Pvaznik;
    s:string;
    v:Punifiltr;
begin
s:='';
q:=p^.dalsi;
while q<>nil do
   begin
   v:=q^.vazba;
   if v^.soubor<>KOD_SEZNAMU_KLAVESNIC then s:=s+', '+v^.soubor;
   q:=q^.dalsi;
   end;
delete(s,1,2);
VypisPreferovanePol:=s;
end;

Procedure UlozitNastaveni;
var kf:TKonfig;
     p:PVaznik;
     v:PKFpolozka;
begin
kf.Init;
kf.NactiKonfiguraci(EXEdir+'blocek.cfg');

p:=kf.Vrat_ID_polozky('pozadi');v:=p^.vazba;
ZrusPString(v^.c);v^.c:=NaPstring(MyStr(gl_pozadi));

p:=kf.Vrat_ID_polozky('popredi');v:=p^.vazba;
ZrusPString(v^.c);v^.c:=NaPstring(MyStr(gl_popredi));

p:=kf.Vrat_ID_polozky('zaklad');v:=p^.vazba;
ZrusPString(v^.c);v^.c:=NaPstring(MyStr(zaklad));

p:=kf.Vrat_ID_polozky('non_unicode_font');v:=p^.vazba;
ZrusPString(v^.c);v^.c:=NaPstring(PrekladFontu(non_unicode_font));

p:=kf.Vrat_ID_polozky('imgfilter');v:=p^.vazba;
ZrusPString(v^.c);v^.c:=NaPstring(MyStr(obrazovy_filtr));

p:=kf.Vrat_ID_polozky('pref_klavesnice');v:=p^.vazba;
ZrusPString(v^.c);v^.c:=NaPstring(VypisPreferovanePol(vidi_klavesnice^.dalsi));

p:=kf.Vrat_ID_polozky('pref_filtry');v:=p^.vazba;
ZrusPString(v^.c);v^.c:=NaPstring(VypisPreferovanePol(seznam_vidifiltru));

p:=kf.Vrat_ID_polozky('pref_asciifiltry');v:=p^.vazba;
ZrusPString(v^.c);v^.c:=NaPstring(VypisPreferovanePol(seznam_vidiasciifiltru));

kf.Zapis(EXEdir+'blocek.cfg');
kf.Done;
OKokno(hlla('info'),hlla('nastaveni_ulozeno'));
end;

Procedure SejmiObrazovku;
var t:Souborovy_Dialog;
    s:string;
begin
mozno_sejmout_obrazovku:=false;  {ochrana pred rekurzi}
t.Init(hlla('jak_to_ulozit'),400,'snimek.bmp');
t.Zobraz;
if t.Bylo_cancel then begin t.Done;mozno_sejmout_obrazovku:=true;Exit;end;
s:=t.hodnota;
t.Done;
if ExistFile(s) then
   if not anoneokno(hlla('soubor_existuje_prepsat')) then Exit;
if Save_BMP(vga,s)=false then
   OKokno(hlla('chyba'),hlla('soubor_nebyl_ulozen'));
mozno_sejmout_obrazovku:=true;
end;

Procedure OtevriInfoTXT;
begin
OtevriSoubor(EXEdir+'info.txt');
end;

Function UniFiltr2string(p:pointer):string;
var v:PuniFiltr;
begin
v:=p;
UniFiltr2string:=v^.nazev;
end;

Procedure Do_UTF8;
var s,ofn:string;
    p:PVaznik;
    v,v2:PEdRadek;
    i,j,vspp:longint;
    n:Pchar;
    c,d:byte;
    utftabulka:utf8conv;
    pw:pchar;
    _pw:string[5];

begin
if ed=nil then Exit;
if ed^.unicode then
   begin
   okokno(hlla('info'),hlla('to_uz_utf8_je'));
   Exit;
   end;
p:=ListboxOknoPlus(NA_STRED-150,NA_STRED-50,250,300,hlla('vyber_filtr'),
               seznam_filtru,seznam_vidifiltru,@UniFiltr2string);
if p=nil then Exit;
s:=PUniFiltr(p^.vazba)^.soubor;
NahrajUTF8tabulku(EXEdir+'key_tbl\'+s,utftabulka);
ofn:=fn_default;
fn_default:=unicode_font;

if ed^.zalamuj then ed^.PospojujRadky(false);
ed^.hlavni_font:=unicode_font;
ed^.unicode:=true;

p:=ed^.radky^.dalsi;
while p<>nil do
   begin
   v:=p^.vazba;
   v2:=New(PEdRadek,Init);
   j:=0;
   i:=0;
   vspp:=v^.spp-2;
   repeat
       c:=byte(v^.p[i]);
       if c<128 then inc(j)
          else begin
          if j>0 then
             begin      {znaky pod 128 ulozim nezmeneny}
             n:=v^.p;
             inc(n,i);d:=byte(n^);n^:=#0; {musim docasne vsadit konec retezce}
             dec(n,j);                    {tady jsem mel ZAKYS JAKO SVINA}
             v2^.Vloz(n,v2^.spp);
             inc(n,j);n^:=char(d);        {a vratim do puvodniho stavu}
             end;
          {a ted zpracuju tajemny znak 128 a vyssi}
          _pw:=Word2Utf8(PrelozZnak(c,utftabulka))+#0;
          pw:=@_pw;inc(pw);
          v2^.Vloz(pw,v2^.spp);
          j:=0;
          end;
   inc(i);
   until i>vspp;
   if j>0 then
      begin
      n:=v^.p;
      inc(n,i-j);             {tady uz neni treba vsazovat konec retezce}
      v2^.Vloz(n,v2^.spp);
      end;
   p^.vazba:=v2;
   dispose(v,Done);
   p:=p^.dalsi;
   end;
fn_default:=ofn;
ed^.PridelRadky;
ed^.VycentrujNaKurzor;
VykresliDolniListu;
ed^.zobraz;
end;

Procedure Z_UTF8;
var p:Pvaznik;
    v,v2:PEdRadek;
    s,ofn:string;
    c,d:byte;
    n:Pchar;
    utftabulka:utf8conv;
    w:word;
    i,j,vspp:longint;
    na_otaznik:boolean;

  Function Index_v_UTFtabulce(w:word):string;
  var kk:longint;
  begin
  if w<128 then Index_v_UTFtabulce:=char(w)+#0 else
     for kk:=128 to 255 do
         if utftabulka[kk]=w then Exit(char(kk)+#0);
  {nikdy by nemelo nastat}
  if not na_otaznik then
     Index_v_UTFtabulce:=Word2UTF8(PrelozZnak(w,utftabulka))+#0
     else Index_v_UTFtabulce:='?'+#0;
  end;

begin
if ed=nil then Exit;
if ed^.unicode=false then
   begin
   okokno(hlla('info'),hlla('neni_v_utf8'));
   Exit;
   end;
p:=ListboxOknoPlus(NA_STRED-150,NA_STRED-50,250,300,hlla('vyber_filtr'),
               seznam_filtru,seznam_vidifiltru,@UniFiltr2string);
if p=nil then Exit;
s:=PUniFiltr(p^.vazba)^.soubor;
NahrajUTF8tabulku(EXEdir+'key_tbl\'+s,utftabulka);
na_otaznik:=anoneokno(hlla('nezname_na_otaznik'));
ofn:=fn_default;
fn_default:=unicode_font;
if ed^.zalamuj then ed^.PospojujRadky(false);
ed^.hlavni_font:=non_unicode_font;
ed^.unicode:=false;
p:=ed^.radky^.dalsi;
while p<>nil do
   begin
   v:=p^.vazba;
   v2:=New(PEdRadek,Init);
   j:=0;
   i:=0;
   vspp:=v^.spp-2;
   repeat
   c:=byte(v^.p[i]);
   if c<128 then inc(j)
      else begin
      if j>0 then
         begin
         n:=v^.p;
         inc(n,i);d:=byte(n^);n^:=#0; {musim docasne vsadit konec retezce}
         dec(n,j);                    {tady jsem mel ZAKYS JAKO SVINA}
         v2^.Vloz(n,v2^.spp);
         inc(n,j);n^:=char(d);        {a vratim do puvodniho stavu}
         end;
      {mam pred sebou unicode znak}
      if c<224 then
         begin                                  {dvojbajtovy znak}
         if i+1>vspp then begin
            w:=63;
            end else
            begin
            w:=(c and 63) shl 6+byte(v^.p[i+1]) and 63;
            inc(i);
            end;
         end
         else begin                             {trojbajtovy znak}
         if i+2>vspp then w:=63 else
            begin
            w:=(c and 15) shl 12+byte(v^.p[i+1]) and 63 shl 6+byte(v^.p[i+2]) and 63;
            inc(i,2);
            end;
         end;

      s:=Index_v_UTFtabulce(w);
      n:=@s;inc(n);
      v2^.Vloz(n,v2^.spp);
      j:=0;
      end;
   inc(i);
   until i>vspp;
   if j>0 then
         begin
         n:=v^.p;
         inc(n,i-j);
         v2^.Vloz(n,v2^.spp);
         end;
   p^.vazba:=v2;
   Dispose(v,Done);
   p:=p^.dalsi;
   end;
fn_default:=ofn;
ed^.PridelRadky;
ed^.VycentrujNaKurzor;
VykresliDolniListu;
ed^.zobraz;
end;

Procedure ZafixujNalamaniRadek;
var p:PVaznik;
    v:PEDradek;
begin
if ed=nil then Exit;
if ed^.zalamuj=false then
   begin
   OKokno(hlla('info'),hlla('nelze_fixovat_zalamani'));
   Exit;
   end;
p:=ed^.radky^.dalsi;
while p<>nil do
   begin
   v:=p^.vazba;
   v^.crlf:=true;
   p:=p^.dalsi;
   end;
end;

Procedure ZmenRozlozeniKlavesnice;
var s:string;
begin
Klin.RozbalSeznam;
aktualni_klavesnice:=klin.hodnota^.vazba;
s:=aktualni_klavesnice^.nazev;
if ed<>nil then
   begin
   ed^.stav:=_aktivni;
   ed^.xm:=-mouse.last_px;
   ed^.ym:=-mouse.last_py;
   end;
end;

Function MyOsetreniKlavesnice(o:word):string;
begin
if o=xTab then Exit(XMezer(tab_na_mezery)+#0);
if o<32 then Exit('');
if aktualni_klavesnice^.soubor='' then
   begin      {pouzivame schema DOS}
   if o>255 then Exit('') else
   if ed^.unicode then
      Exit(Word2UTF8(PrelozZnak(o,moje_utf8_tbl))+#0) else Exit(char(o)+#0);
   end
   else begin {pouzivame svoje schema}
   if ed^.unicode then Exit(Word2UTF8(o)+#0)
                  else Exit(char(o)+#0);
   end;
end;

Function MyPostupNahravani(r:real):boolean;
var o:word;
    s:string;
begin
if r=-1 then s:='' else begin Str(r:2:0,s);s:=s+'%';end;
UkazPocetZmen(s);
if xKeyPressed then o:=xReadkey;
if o=xESC then
   begin
   MouseSetCursor(UKmys);
   if Anoneokno(hlla('zrusit_nac')) then exit(false);
   MouseSetCursor(UKmysCekej);
   end;
MyPostupNahravani:=true;
end;

Procedure Klin_pohlidej;
var p1,p2:pointer;
begin
p1:=klin.hodnota;
klin.kontrola;
p2:=klin.hodnota;
if p1<>p2 then aktualni_klavesnice:=klin.hodnota^.vazba;
end;

Function DejVyskyt:PVaznik;
var p:PVaznik;
begin
p:=ed^.posledni_vyskyt.r;
if p^.predchozi<>ed^.radky then p:=p^.predchozi;
DejVyskyt:=p;
end;

Procedure NahradaTextu(p:PVaznik;poz:longint;text1,text2:string);
var v:PEdRadek;
    l:longint;
    os:string;
begin
v:=p^.vazba;
l:=Length(text1);
v^.Vyjmi(poz,l);
v^.VlozS(text2,poz);
os:=FN_default;
NastavFont(ed^.hlavni_font);
l:=Sirka_FN(v^.p,l_f);
v^.gd:=l;
NastavFont(os);
end;

Function Potvrd_Zmenu(v:PEdRadek):byte;
var x,y,sirka,vyska:longint;
begin
ZjistiRozmeryTextu(hlla('nahradit_vyskyt'),sirka,vyska,nil);
inc(sirka,10);    {okno ve skutecnosti zabere o 50px vic do sirky}
inc(vyska,50);    {a o 10px do vysky}

x:=ed^.kx;
y:=(v^.y1+_ey-ed^.poc_ZobrY)-vyska-10;
if y<0 then y:=(v^.y2+_ey-ed^.poc_zobrY)+10;
if x+sirka>vga.breiteminus1 then x:=vga.breiteminus1-sirka;
Potvrd_Zmenu:=polohovane_anonezrusokno(x,y,hlla('nahradit_vyskyt'));
end;

Function StartovniPoloha:TkurPoz;
var t:TKurPoz;
begin
t.x:=1;
t.y:=1;
t.r:=ed^.radky^.dalsi;
end;

Function Hledej_Jadro(text,text2:string;rezim:byte;mapa:pointer;rozlisuj:boolean;nahrada:byte):boolean;
var p:PVaznik;
    v:PEDRadek;
    zmp:pointer;
    i,ii,j,k,dt,px:longint;
    ptag,ztag,u:pchar;
    h,hh,mam_to:boolean;
    ht:byte;
    zvr,debugs:string;
begin
case rezim of
   1:begin p:=ed^.pozice.r;ii:=ed^.pozice.x;end;
   2:begin p:=ed^.pozice.r;px:=ed^.pozice.x;ii:=1;end;
   3:begin p:=ed^.radky^.dalsi;ii:=1;end;
   4:begin {od posl. nalezu vpred}
     if ed^.posledni_vyskyt.r=nil then ed^.posledni_vyskyt:=StartovniPoloha
        else inc(ed^.posledni_vyskyt.x,Length(text2));
     p:=ed^.posledni_vyskyt.r;
     rezim:=1;
     v:=p^.vazba;
     if ed^.posledni_vyskyt.x>=v^.spp then ed^.posledni_vyskyt.x:=v^.spp-1;
     i:=ed^.posledni_vyskyt.x;
     if i>=v^.spp-1 then
        begin
        ii:=1;
        p:=p^.dalsi;
        end
       else ii:=i+FNznakvpred(v^.p,i-1,ed^.unicode,k);
     end;
   5:begin {od posl. nalezu vzad}
     if ed^.posledni_vyskyt.r=nil then ed^.posledni_vyskyt:=ed^.pozice;
     p:=ed^.posledni_vyskyt.r;
     rezim:=2;
     v:=p^.vazba;
     if ed^.posledni_vyskyt.x>=v^.spp then ed^.posledni_vyskyt.x:=v^.spp-1;
     px:=ed^.posledni_vyskyt.x;
     ii:=1;
     end;
end; {case}
zmp:=velke_na_male;
velke_na_male:=mapa;
   if rozlisuj=false then text:=Convert_Down(text);
   zvr:='<POZADI='+MyStr(zvyraznovac)+'>'+#0;
   ptag:=@zvr[1];
   ztag:='<SP>';
   mam_to:=false;
   h:=true;
   while (p<>nil) and (p^.predchozi<>nil) do
      begin
      v:=p^.vazba;

      if v^.spp=0 then
         begin
         debugs:=v^.p;
         end;

      if H then
         if rozlisuj then u:=v^.p else
            begin
            u:=v^.ExportujPchar;
            pConvert_Down(v^.p,u);
            end;
      i:=pSearch(u,v^.spp-1,text,ii);
      if rozlisuj then Freemem(u);
      if i<>0 then
         if rezim=2 then  {kdyz najdu vyskyt pri zpetnem hledani,}
            begin         {tak zi zapamatuju pozici a budu hledat dal}
            if (p<>ed^.pozice.r) or (i<px) then
               begin
               ii:=i+1;
               h:=false;
               end
               else
               begin
               if h=false then
                  begin
                  i:=ii-1;
                  mam_to:=true;
                  end;
               end;
            end else {i<>0, rezim<>2}mam_to:=true
              else   {i=0}
              if h=false then  {muze nastat jen pri rezim=2}
                 begin
                 i:=ii-1;
                 if (p=ed^.pozice.r) and (i>px) then
                    Break else mam_to:=true;
                 end;
      if mam_to then
         begin
         Hledej_jadro:=true;
         ed^.pozice.x:=i;
         ed^.pozice.y:=v^.yy;
         ed^.pozice.r:=p;
         ed^.posledni_vyskyt:=ed^.pozice;
         ed^.VycentrujNaKurzor;

         hh:=(nahrada=0) or ((nahrada and NH_PREPTEJ_SE)<>0);

         if hh then
            begin
            dt:=Length(text);
            v^.Vloz(ztag,i+dt);
            v^.Vloz(ptag,i);
            end;
         ed^.zobraz;

         ht:=0;
         if nahrada=0 then Cekej else
            if (nahrada and NH_PREPTEJ_SE)<>0 then
               begin
               ht:=Potvrd_zmenu(v);
               end else ht:=1;

         if hh then
            begin
            v^.Vyjmi(i,Length(string(ptag)));
            v^.Vyjmi(i+dt,Length(string(ztag)));
            ed^.zobraz;
            end;

         if Ht=2 then
            begin
            velke_na_male:=zmp;
            Exit(false);
            end;

         if Ht=1 then
            begin
            NahradaTextu(p,i,text,text2);
            ed^.Zobraz;
            end;

         velke_na_male:=zmp;

         Exit;
         end;
      if h then
         begin
         if rezim=2 then p:=p^.predchozi else p:=p^.dalsi;
         ii:=1;
         end;
      end;
velke_na_male:=zmp;

if (nahrada and NH_ZMEN_VSE)=0 then
   OKokno(hlla('info'),hlla('text_nenalezen'));
Ed^.posledni_vyskyt.r:=nil;
Hledej_jadro:=false;
end;

Procedure Hledej;
var ok:pokno;
    tx:textovepole;
    i,i2,vf:longint;
    za:pzatrzitko;
    se:TSeznam;
    pr:pPrepinac;
    o:word;
    okt,zrust:PTlacitko;
    stav:(sneurcen,sano,sne);
    rezim:byte;
    filtr:pointer;
    rozlisuj:boolean;
    sf,text:string;
    objektiky:PVaznik;
begin
if ed=nil then Exit;
jsem_v_hlavnim_okne:=false;
vf:=Vyska_FN(AktualniFont);
{--------------------------- Vykreslovaci cast -----------------------------}
sf:=FN_default;
{usnadnim si praci - vykreslim jakoby mustr anoneokna}
anoneokno_mustr(ok,330,200,hlla('vyhledavani'),'',hlla('ok'),hlla('zrus'),okt,zrust);

{a upravim si ho podle sveho}
i:=ok^.y+ok^.vyska_zahlavi+5;
if ed^.unicode then NastavFont(unicode_font);
tx.init(ok^.x+5,i,300,'',true,false);
NastavFont(sf);
tx.TX_key_proc:=@MyEdProc;
tx.mimoradne_osetreni_klavesnice:=@MyOsetreniKlavesnice;
inc(i,tx.vyska+10);
pr:=new(PPrepinac,init(ok^.x+5,i,hlla('rezim_vyhled'),hlla('vyhled_mozn'),'',1));
za:=new(Pzatrzitko,init(ok^.x+5,i+50+tx.vyska+10,hlla('roz_vel_pismen'),'',false));
i2:=za^.y+vf*2+10;
print_FN(ok^.x+5,i2,hlla('mapa_shodnosti'),l_f);
FN_color:=0;
if ed^.unicode then
   begin
   print_FN(ok^.x+5,i2+vf,hlla('hl_unicode'),l_f);
   {NastavFont(unicode_font);}
   end
   else se.init(ok^.x+5,i2+vf-4,128,450,moje_klavesnice,klin.hodnota,@UniFiltr2string);

objektiky:=Svazej(
           uzel(pr,
           uzel(za,
           uzel(okt,
           uzel(zrust,nil))))
                 );

{---------------------------------------------------------------------------}

{----------------------------- Funkcni cast --------------------------------}
stav:=sneurcen;
repeat
tx.kontrola;
if (tx.stav<>_aktivni) and (xLastKey=0) then
   if xKeyPressed then xReadkey;
if xLastKey<>0 then
      if mimoradny_kod=0 then
      case xLastKey of
         xEnter:stav:=sano;
         xESC:stav:=sne;
      end
      else case mimoradny_kod of{mimoradny_kod<>0}
         ALT_SHIFT:begin
                   ZmenRozlozeniKlavesnice;
                   tx.xm:=-mouse.last_px;
                   tx.ym:=-mouse.last_py;
                   end;
      end; {case}

Klin_pohlidej;
Vse_Kontrola(objektiky);

if okt^.hodnota=1 then stav:=sano;
if zrust^.hodnota=1 then stav:=sne;
if ed^.unicode=false then se.kontrola;
xLastKey:=0;
until stav<>sneurcen;
rezim:=pr^.hodnota;
rozlisuj:=za^.hodnota;
if rozlisuj=false then
   if ed^.unicode=false then
      filtr:=PUnifiltr(se.hodnota^.vazba)^.t_velke_na_male else
      filtr:=UNI_velke_na_male;
text:=tx.VratHodnotu(false);
if ed^.unicode=false then se.done;
tx.Done;
Vse_zlikviduj(objektiky);
Dispose(ok,Done);
jsem_v_hlavnim_okne:=true;
NastavFont(sf);
if (stav=sano) and (text<>'') then
   begin
   ed^.posledni_hledany_retezec:=text;
   globalne_posledni_hledany_retezec:=text;
   globalni_rezim_hledani:=rezim;
   globalni_filtr:=filtr;
   globalni_rozlisuj:=rozlisuj;
   Hledej_jadro(text,'',rezim,filtr,rozlisuj,0);
   end;
end;

Procedure OpakujHledani;
var mrh:byte;
begin
if ed=nil then Exit;
if globalne_posledni_hledany_retezec='' then
   begin Hledej;Exit;end;

if ed^.posledni_vyskyt.r=nil then
   begin OKokno(hlla('info'),hlla('text_nenalezen'));Exit;end;

if globalne_posledni_hledany_retezec=ed^.posledni_hledany_retezec then
   if globalni_rezim_hledani=2 then mrh:=5 else mrh:=4
   else if globalni_rezim_hledani=1 then mrh:=3 else mrh:=globalni_rezim_hledani;
ed^.posledni_hledany_retezec:=globalne_posledni_hledany_retezec;
Hledej_Jadro(globalne_posledni_hledany_retezec,'',
             mrh,
             globalni_filtr,
             globalni_rozlisuj,0);
end;

Procedure Nahrad;
var ok:pokno;
    tx1,tx2:ptextovepole;
    vv,txtpolicka,objektiky:PVaznik;
    i,i2,vf:longint;
    za,za2,za3:pzatrzitko;
    se:TSeznam;
    pr:pPrepinac;
    o:word;
    okt,zrust:PTlacitko;
    stav:(sneurcen,sano,sne);
    rezim,rezim2:byte;
    filtr:pointer;
    rozlisuj,vh,byl_nalez:boolean;
    pocet_zmen:longint;
    zz:TKurPoz;
    sf,text,text2:string;
begin
if ed=nil then Exit;
jsem_v_hlavnim_okne:=false;

{--------------------------- Vykreslovaci cast -----------------------------}
sf:=FN_default;
anoneokno_mustr(ok,330,300,hlla('nahrada_textu'),'',hlla('ok'),hlla('zrus'),okt,zrust);
vf:=Vyska_FN(AktualniFont);

i:=ok^.y+ok^.vyska_zahlavi+5+vf;

Print_FN(ok^.x+5,i,hlla('hledany_text'),l_f);
Print_FN(ok^.x+5,i+vf+vf+10,hlla('novy_text'),l_f);

if ed^.unicode then NastavFont(unicode_font);
tx1:=New(PTextovepole,init(ok^.x+5,i+4,300,'',true,false));
tx2:=New(PTextovepole,init(ok^.x+5,i+vf+vf+10+4,300,'',false,false));
NastavFont(sf);
tx1^.TX_key_proc:=@MyEdProc;
tx1^.mimoradne_osetreni_klavesnice:=@MyOsetreniKlavesnice;
tx2^.TX_key_proc:=@MyEdProc;
tx2^.mimoradne_osetreni_klavesnice:=@MyOsetreniKlavesnice;
inc(i,vf*4+10);
pr:=new(pPrepinac,init(ok^.x+5,i,hlla('rezim_vyhled'),hlla('vyhled_mozn'),'',1));

inc(i,50);

za:=New(PZatrzitko,init(ok^.x+5,i+tx1^.vyska+10,hlla('roz_vel_pismen'),'',false));
za2:=New(PZatrzitko,init(ok^.x+5,i+tx1^.vyska+vf+10,hlla('nahradvse'),'',false));
za3:=New(PZatrzitko,init(ok^.x+5,i+tx1^.vyska+vf+vf+10,hlla('potvrzovat'),'',false));
i2:=za^.y+vf*4+10;
print_FN(ok^.x+5,i2,hlla('mapa_shodnosti'),l_f);
FN_color:=0;
if ed^.unicode then
   begin
   print_FN(ok^.x+5,i2+vf,hlla('hl_unicode'),l_f);
   {NastavFont(unicode_font);}
   end
   else se.init(ok^.x+5,i2+vf-4,128,450,moje_klavesnice,klin.hodnota,@UniFiltr2string);
{---------------------------------------------------------------------------}
txtpolicka:=Svazej(
            uzel(tx1,
            uzel(tx2,nil))
                  );
objektiky:=Svazej(
           uzel(pr,
           uzel(za,
           uzel(za2,
           uzel(za3,
           uzel(okt,
           uzel(zrust,nil))))))
                 );
{----------------------------- Funkcni cast --------------------------------}
stav:=sneurcen;
repeat
Vse_kontrola(txtpolicka);
vv:=Vse_zda_aktivni(txtpolicka);
if (vv=nil) and (xLastKey=0) then
   if xKeyPressed then xReadkey;
if xLastKey<>0 then
      if mimoradny_kod=0 then
      case xLastKey of
         xEnter:stav:=sano;
         xESC:stav:=sne;
      end
      else case mimoradny_kod of{mimoradny_kod<>0}
         ALT_SHIFT:begin
                   ZmenRozlozeniKlavesnice;
                   if vv<>nil then
                      begin
                      PTextovePole(vv^.vazba)^.xm:=-mouse.last_px;
                      PTextovePole(vv^.vazba)^.ym:=-mouse.last_py;
                      end;
                   end;
      end; {case}
Klin_pohlidej;
Vse_kontrola(objektiky);
{if klin.hodnota=1 then}
if okt^.hodnota=1 then stav:=sano;
if zrust^.hodnota=1 then stav:=sne;
if ed^.unicode=false then se.kontrola;
xLastKey:=0;
until stav<>sneurcen;
rezim:=pr^.hodnota;
rozlisuj:=za^.hodnota;
rezim2:=NH_NAHRAD;
if za3^.hodnota then rezim2:=rezim2+NH_PREPTEJ_SE;
if za2^.hodnota then rezim2:=rezim2+NH_ZMEN_VSE;
if rozlisuj=false then
   if ed^.unicode=false then
      filtr:=PUnifiltr(se.hodnota^.vazba)^.t_velke_na_male else
      filtr:=UNI_velke_na_male;
text:=tx1^.VratHodnotu(false);
text2:=tx2^.VratHodnotu(false);
if ed^.unicode=false then se.done;
Vse_zlikviduj(txtpolicka);
Vse_zlikviduj(objektiky);
Dispose(ok,Done);
jsem_v_hlavnim_okne:=true;
NastavFont(sf);
if (stav=sano) and (text<>'') then
   begin
   if (rezim2 and NH_ZMEN_VSE)=0 then
      begin
      Hledej_Jadro(text,text2,rezim,filtr,rozlisuj,rezim2);
      if ed^.zalamuj then
         begin
         vv:=DejVyskyt;
         ed^.NalamejBuffer(vv);
         ed^.Zobraz;
         end;
      end
      else begin
      {Mnohohasobna nahrada textu}
      case rezim of
         3:begin
           ed^.posledni_vyskyt:=StartovniPoloha;
           rezim:=4;
           end;
         1:begin
           ed^.posledni_vyskyt:=ed^.pozice;
           rezim:=4;
           end;
         2:begin
           ed^.posledni_vyskyt:=ed^.pozice;
           rezim:=5;
           end;
      end;
      if (rezim2 and NH_PREPTEJ_SE)=0 then {aby se furt zbytecne nezobrazovaly zmeny}
         begin
         MouseSetCursor(UKmysCekej);
         ed^.zobrazovat:=false;
         end;

      vv:=nil;
      byl_nalez:=false;
      pocet_zmen:=0;
      repeat
      vh:=Hledej_Jadro(text,text2,rezim,filtr,rozlisuj,rezim2);
      if vh then
         begin
         byl_nalez:=true;
         inc(pocet_zmen);
         if pocet_zmen mod krok_v_nahradach = 0 then UkazPocetZmen(hlla('pocet_zmen')+' '+MyStr(pocet_zmen));
         end;
      if (vv=nil) and (rezim=4) and (vh=true) then vv:=DejVyskyt;
      until vh=false;
      UkazPocetZmen('');      {byl-li ukazovan progresbar, tak ho ted smaze}
      if (rezim=5) and byl_nalez and ed^.zalamuj then vv:=DejVyskyt;

      if ed^.zalamuj then ed^.NalamejBuffer(vv);

      if ((rezim2 and NH_PREPTEJ_SE)=0) then MouseSetCursor(UKmys);
      if ((rezim2 and NH_PREPTEJ_SE)=0) or (ed^.zalamuj) then
         begin
         ed^.zobrazovat:=true;
         ed^.Zobraz;
         end;
      end;
   end;
end;

Procedure VyberFiltr;
var za:PPrepinac;
    i,y:longint;
    ok:pokno;
    okt,zrust:PTlacitko;
    o:word;
    s:byte;
begin
anoneokno_mustr(ok,250,300,hlla('vyber_filtr'),'',hlla('ok'),hlla('zrus'),okt,zrust);
y:=ok^.y+ok^.vyska_zahlavi-5;
za:=New(PPrepinac,Init(ok^.x+5,y,' ',
        'Qick''n''dirty'#13#10'Nearest'#13#10'Box'#13#10'Bilinear'#13#10+
        'Hanning'#13#10'Hamming'#13#10'Hermite'#13#10'Bell'#13#10+
        'Catrom'#13#10'Bicubic'#13#10'Spline'#13#10'Mitchell'#13#10+
        'Gaussian'#13#10'Spline2'#13#10'SinC'#13#10'Lanczos'#13#10'Blackman',
        '',obrazovy_filtr));
s:=0;
repeat
if xKeyPressed then
   begin
   o:=xReadkey;
   if o=xEnter then s:=1;
   if o=xESC then s:=2;
   end;
okt^.kontrola;zrust^.kontrola;za^.kontrola;
if okt^.klik=1 then s:=1;
if zrust^.klik=1 then s:=2;
until s<>0;

if s=1 then obrazovy_filtr:=za^.hodnota;

Dispose(za,Done);
Dispose(okt,Done);
Dispose(zrust,Done);
Dispose(ok,Done);
end;

Procedure NakresliBunku(n:PZnakTab;pop,pop2,poz:word;f,m:fn;v:virtualwindow);
var e:word;
    s:string;
    aa,i:longint;
begin
FN_ignore:=false;
NastavVystup(v);
e:=n^.znak;
Rectangle(v,n^.x1,n^.y1,n^.x2,n^.y2,65535);
i:=(n^.x1+n^.x2) div 2;
if f^.znak^[e].data=nil then Bar(v,n^.x1+1,n^.y1+1,n^.x2-1,n^.y2-1,742)
   else begin
   Bar(v,n^.x1+1,n^.y1+1,n^.x2-1,n^.y2-1,poz);
   if f^.unicode then s:=Word2UTF8(e) else s:=char(e);
   FN_color:=pop;
   Print_FN(i-(f^.znak^[e].sirka div 2),n^.y1+f^.so+2,s,f);
   end;
FN_color:=pop2;
s:=Mystr(e);
aa:=Sirka_FN(s,m) div 2;
Print_FN(i-aa,n^.y2-m^.so,s,m);
s:=Dec2Hex(e)+'h';
aa:=Sirka_FN(s,m) div 2;
Print_FN(i-aa,n^.y2-1,s,m);
NastavVystup(vga);
FN_ignore:=true;
end;

Procedure DataUnicodeTabulky(g:fn;i,j:longint;p:Pvaznik;var a,b:longint);
var n,k,e,f:longint;
    v:PZnakTab;
begin
n:=-1;
k:=0;
e:=0;
f:=0;
repeat
inc(n);
if g^.znak^[n].data<>nil then
   begin
   inc(k);
   New(v);
   v^.znak:=n;
   v^.x1:=e;
   v^.y1:=f;
   v^.x2:=e+i;
   v^.y2:=f+j;
   inc(e,i);
   if k mod 16=0 then
      begin
      a:=v^.x2+1;
      e:=0;
      inc(f,j);
      end;
   p:=p^.InitNext(v);
   end;
until k=g^.poc_znaku;
b:=v^.y2+1;
end;

Procedure DataASCIItabulky(i,j:longint;p:PVaznik;var a,b:longint);
var v:PZnakTab;
    c,d,e,f:longint;
begin
a:=i*16+1;
b:=j*16+1;
f:=0;
for d:=0 to 15 do
    begin
    e:=0;
    for c:=0 to 15 do
        begin
        New(v);
        v^.znak:=d*16+c;
        v^.x1:=e;
        v^.y1:=f;
        v^.x2:=e+i;
        v^.y2:=f+j;
        e:=v^.x2;
        p:=p^.InitNext(v);
        end;
    f:=v^.y2;
    end;
end;

Procedure VykresliBunky(p:PVaznik;f,m:fn;v:virtualwindow);
var q:PVaznik;
    e:PZnakTab;
begin
q:=p^.dalsi;
while q<>nil do
   begin
   e:=q^.vazba;
   NakresliBunku(e,65535,330,1234,f,m,v);
   q:=q^.dalsi;
   end;
end;

Function Urci_znak_v_tabulce(p:PVaznik;mx,my:longint):PZnakTab;
var q:PVaznik;
    v:PZnakTab;
begin
q:=p^.dalsi;
while q<>nil do
   begin
   v:=q^.vazba;
   if Uvnitr(mx,my,v^.x1,v^.y1,v^.x2,v^.y2) then Exit(v);
   q:=q^.dalsi;
   end;
Exit(nil);
end;

Procedure ZnicZnakTab(var p:pointer);
var v:PZnakTab;
begin
v:=p;
Dispose(v);
p:=nil;
end;

Procedure MapaZnaku;
var f,m:fn;
    a,b,i,j:longint;
    sx,sy,mx,my:longint;
    kp:pchar;
    ks:string;
    hv:boolean;
    p:Pvaznik;
    v,zal:virtualwindow;
    vz,ovz:PZnakTab;
    vw:PVWokno;

begin
if (ed<>nil) and (ed^.unicode=true) then f:=String2FN(ed^.hlavni_font)
   else f:=String2FN(non_unicode_font);

Nacti_FN('cour10.fn',m);
a:=Sirka_FN('255',m);
i:=abs(f^.maxpred)+abs(f^.maxza);
if i<a+4 then i:=a+4;
j:=abs(f^.maxnad)+abs(f^.maxpod)+(m^.so+m^.su)*2;
p:=New(PVaznik,Init(nil,nil));

if f^.unicode then DataUnicodeTabulky(f,i,j,p,a,b)
              else DataASCIItabulky(i,j,p,a,b);
Init_VW(v,a,b,false);
Clr(v,742);
VykresliBunky(p,f,m,v);
a:=v.breite+Sirka_pos;
if v.hoehe>460 then b:=460 else b:=v.hoehe;
hv:=hned_vykresluj;
hned_vykresluj:=false;
vw:=New(PVWOkno,Init(NA_STRED,NA_STRED,a,b,v,false,true));
vw^.kresli_ramecek:=false;
hned_vykresluj:=hv;
Init_VW(zal,a+1,b+1,false);
MouseHide;
GetSprite(vga,zal,vw^.x,vw^.y);
MouseShow;
vw^.zobraz;

sx:=-1;
sy:=-1;
ovz:=nil;
repeat
vw^.kontrola;
if xLastKey=xESC then
   begin
   vz:=nil;
   Break;
   end;
mx:=mouse.x;
my:=mouse.y;
if (mx<>sx) or (my<>sy) then
   begin
   sx:=mx;
   sy:=my;
   if Uvnitr(mx,my,vw^.x,vw^.y,vw^.x+vw^.sirka-17,vw^.y+vw^.vyska-17)
      then begin
      mx:=mx-vw^.x+vw^.poc_ZobrX;
      my:=my-vw^.y+vw^.poc_ZobrY;
      vz:=Urci_znak_v_tabulce(p,mx,my);
      if (vz<>nil) and (vz<>ovz) then   {VZ by NIL nemelo byt nikdy}
         begin
         if ovz<>nil then NakresliBunku(ovz,65535,330,1234,f,m,v);
         NakresliBunku(vz,655,25356,7,f,m,v);
         vw^.Zobraz;
         ovz:=vz;
         end;
      end else vz:=nil;
   end;
if vw^.mys_klikla_uvnitr then
   begin
   if vw^.stav<>_aktivni then a:=-1;
   if (vw^.py.mys_uvnitr=false) and (vw^.py.probehni=false) then Break;
   end;
until vw^.stav<>_aktivni;

MouseRel;
if (vz<>nil) and (ed<>nil) then
   begin
   a:=vz^.znak;
   if f^.znak^[a].data<>nil then
      begin
      if f^.unicode then ks:=Word2UTF8(a) else ks:=char(a)+#0;
      if ks[1]='<' then
         begin
         ks:='<<'+#0;
         b:=2;
         end else
      if ks[1]='>' then
         begin
         ks:='>>'+#0;
         b:=2;
         end else b:=1;
      kp:=@ks;inc(kp);
      ed^.PridejTextNaPoziciKurzoru(kp,b);
      end;
   end;
MouseHide;
PutSprite(vga,zal,vw^.x,vw^.y);
MouseShow;
Kill_VW(zal);
Dispose(vw,Done);
Vaznik_Done_All(p,@ZnicZnakTab);
Kill_VW(v);
Znic_FN(m);
if ed<>nil then
   begin
   ed^.stav:=_aktivni;
   ed^.xm:=-mouse.last_px;
   ed^.ym:=-mouse.last_py;
   ed^.zobraz;
   end;
end;

Procedure Informace_o_pameti;
begin
Okokno(hlla('info'),hllp(hlasky,'pametinfo'));
end;

Procedure VyberPrefKlav;
var a1,b1,b2,p:PVaznik;
    o,k:word;
begin
a1:=New(PVaznik,Init(nil,nil));
b1:=New(PVaznik,Init(nil,nil));
b2:=New(PVaznik,Init(nil,nil));
a1^.vazba:=moje_klavesnice^.dalsi^.vazba;
b1^.vazba:=vidi_klavesnice^.dalsi^.vazba;
b2^.vazba:=vidi_klavesnice^.Searchlast^.vazba;

Dispose(moje_klavesnice^.dalsi,Done);
Dispose(vidi_klavesnice^.dalsi,Done);
Dispose(vidi_klavesnice^.Searchlast,Done);
p:=DvojListbox(hlla('vybprefkl'),500,350,@UniFiltr2string,moje_klavesnice,vidi_klavesnice);

Vaznik_done_all(vidi_klavesnice);
vidi_klavesnice:=p;
vidi_klavesnice^.Insert(b1);
vidi_klavesnice^.Searchlast^.Insert(b2);
moje_klavesnice^.Insert(a1);
o:=klin.mojebarva;
k:=FN_color;
klin.done;
FN_color:=o;
klin.init(vga.breite-130,1,128,450,vidi_klavesnice,vidi_klavesnice^.dalsi,@UniFiltr2string);
aktualni_klavesnice:=vidi_klavesnice^.dalsi^.vazba;
FN_color:=k;
end;

Procedure VyberPrefFiltry(var vse,vyb:PVaznik);
var b2,p:PVaznik;
begin
b2:=New(PVaznik,Init(nil,nil));
b2^.vazba:=vyb^.Searchlast^.vazba;
Dispose(vyb^.Searchlast,Done);
p:=DvojListbox(hlla('vybprefflt'),500,350,@UniFiltr2string,vse,vyb);
Vaznik_done_all(vyb);
vyb:=p;
vyb^.Searchlast^.Insert(b2);
end;

Procedure Proved_ASCII_konverzi(pp:Pvaznik;a,b:byte);
var s:string;
    p1,p2,q,qq:PVaznik;
    v1,v2:pASCIIkonv;
    v:PEdRadek;
    i,j,k:longint;
    c:char;
    ob:word;
    tab:array[0..255] of byte;
begin
p1:=pp^.Searchrecord(a);
p2:=pp^.Searchrecord(b);
v1:=p1^.vazba;
v2:=p2^.vazba;
i:=0;
ob:=FN_color;
FN_color:=0;
s:=v1^.nazev+#13#10'--->> '+v2^.nazev+#13#10+hlla('pocet_zmen')+' ';
for i:=128 to 255 do
    begin
    j:=Pos(char(i),v1^.mapa);
    if j=0 then tab[i]:=0 else tab[i]:=j;
    end;
if ed^.zalamuj then ed^.PospojujRadky(false);
q:=ed^.radky^.dalsi;
while q<>nil do
   begin
   v:=q^.vazba;
   if v^.spp>1 then
      begin
      for j:=0 to v^.spp-1 do
          begin
          c:=v^.p[j];
          if c>#127 then
             begin
             k:=tab[byte(c)];
             if k<>0 then
                begin
                v^.p[j]:=v2^.mapa[k];
                inc(i);
                end;
             if i mod krok_v_nahradach=0 then UkazPocetZmen(s+MyStr(i));
             end;
          end;
      end;
   q:=q^.dalsi;
   end;
UkazPocetZmen('');
FN_color:=ob;
ed^.PridelRadky;
ed^.VycentrujNaKurzor;
ed^.zobraz;
end;

Function DetekceASCIIkodovani(kody:PVaznik):byte;
var v:pASCIIkonv;
    pr:PEdRadek;
    w:pASCIIkonv;
    p,q:PVaznik;
    n:pchar;
    i,j,k,l:longint;
begin
i:=0;
p:=ed^.radky^.dalsi;
while p<>nil do
   begin
   pr:=p^.vazba;
   n:=pr^.p;
   for j:=0 to pr^.spp do
       begin
       if n[j]>#127 then
          begin
          q:=kody^.dalsi;
          while q<>nil do
             begin
             w:=q^.vazba;
             k:=Pos(n[j],w^.mapa);
             if k<>0 then inc(w^.pocet);
             q:=q^.dalsi;
             end;
          end;
       end;
   p:=p^.dalsi;
   inc(i);
   if i>POCET_PROHLIZENYCHRADKU_PRI_ASCII_DETEKCI then Break;
   end;
q:=kody^.dalsi;
i:=0;
j:=0;
k:=1;
while q<>nil do
   begin
   inc(j);
   w:=q^.vazba;
   l:=w^.pocet;
   if w^.pocet>i then
      begin
      i:=w^.pocet;
      k:=j;
      end;
   q:=q^.dalsi;
   end;
DetekceASCIIkodovani:=k;
end;

Procedure Vyber_Kodovaci_ASCII_schema(soubor:string);
var s,n1,n2:string;
    f:text;
    i:byte;
    j,k,kk,ll,h:longint;
    p:PVaznik;
    v:pASCIIkonv;
    ok:pokno;
    okt,zrt:Ptlacitko;
    pr1,pr2:TPrepinac;
    mujstav:byte;
    o:word;
    bo:boolean;

begin
p:=New(PVaznik,Init(nil,nil));
n1:='';
n2:='';
Assign(f,EXEdir+'KEY_TBL\'+soubor);
Reset(f);
readln(f,s);
i:=0;
k:=0;
j:=vyska_fn(l_f)*2+10;
while not eof(f) do
   begin
   readln(f,s);
   if s[1]='[' then
      begin
      new(v);
      p^.InitNext(v);
      delete(s,1,1);
      delete(s,Length(s),1);
      inc(j,rychlavyskaradky(s));
      kk:=sirka_FN(s,l_f);
      if kk>k then k:=kk;
      n2:=n2+s+#13#10;
      v^.nazev:=s;
      v^.mapa:='';
      v^.pocet:=0;
      inc(i);
      end
      else begin
      s:=skipallspaces(s);
      if s<>'' then v^.mapa:=v^.mapa+s;
      end;
   end;
delete(n2,Length(n2),1);
Close(f);
if i>0 then
   begin
   n1:=hlla('asciiauto');
   inc(j,rychlavyskaradky(n1));
   kk:=sirka_FN(n1,l_f);
   n1:=n2+#13#10+n1;
   if kk>k then k:=kk;
   inc(i);
   anoneokno_mustr(ok,k*2+50,j+10,hlla('vyber_filtr'),'',hlla('ok'),hlla('zrus'),okt,zrt);
   ll:=ok^.x+4;
   kk:=ok^.y+ok^.vyska_zahlavi+5;
   pr1.init(ll,kk,hlla('vkod'),n1,'',i);
   pr2.init(ll+k+25,kk,hlla('ckod'),n2,'',1);
   repeat
      mujstav:=0;
      repeat
      o:=0;
      if xKeypressed then o:=xReadkey;
         pr1.kontrola;
         pr2.kontrola;
         okt^.kontrola;
         zrt^.kontrola;
         if okt^.klik=1 then mujstav:=1;
         if zrt^.klik=1 then mujstav:=2;
         if o=xEnter then mujstav:=1;
         if o=xESC then mujstav:=2;
      until mujstav<>0;

      if (mujstav=1) and (pr1.hodnota=pr2.hodnota) then mujstav:=2;
      if (mujstav=1) and (pr1.hodnota=i) then
         begin
         bo:=Anoneokno(hlla('asciiautovaruj'));
         if bo=false then mujstav:=3;
         end;
   until mujstav<>3;
   Dispose(okt,Done);
   Dispose(zrt,Done);
   Dispose(ok,Done);
   end;
if mujstav=1 then
   begin
   if pr1.hodnota=i then pr1.hodnota:=DetekceASCIIkodovani(p);
   Proved_ASCII_konverzi(p,pr1.hodnota,pr2.hodnota);
   end;
Vaznik_Done_All(p,@KillPuniFiltr);
end;

Procedure ASCIIkonverze;
var p:PVaznik;
    v:Punifiltr;
begin
if ed=nil then Exit;
if ed^.unicode then
   begin
   okokno(hlla('info'),hlla('asciihelp'));
   Exit;
   end;
p:=ListboxOknoPlus(NA_STRED-150,NA_STRED-50,250,300,hlla('vyber_filtr'),
               seznam_asciifiltru,seznam_vidiasciifiltru,@UniFiltr2string);
if p=nil then Exit;
v:=p^.vazba;
Vyber_Kodovaci_ASCII_schema(v^.soubor);
end;

Procedure AktivaceMenu(i:longint);
var p,q:PStrom;
    j:longint;
begin
MouseRel;
p:=vb^.AktivujMenu(i);
if p<>nil then
   begin
   j:=VybraneID(p);
   case j of
      11:NovySoubor;
      12:OtevriSoubor('');
      13:UlozSoubor('');
      14:DOS_skok;
      15:UkonciProgram;
      16:begin zadost_o_zavreni:=-1;ZavriOkno_z_menu;end;
      21:begin gl_popredi:=VyberHicolorBarvuOkno(hlla('vyber_barvu_popredi'),0);if ed<>nil then ed^.popredi:=gl_popredi;end;
      22:begin gl_pozadi:=VyberHicolorBarvuOkno(hlla('vyber_barvu_pozadi'),15);if ed<>nil then ed^.ZmenBarvuPozadi(gl_pozadi);end;
      23:ZmenBarvuZakladu;
      24:VyberFont;
      25:VyberFiltr;
      26:VyberPrefKlav;
      27:VyberPrefFiltry(seznam_filtru,seznam_vidifiltru);
      28:UlozitNastaveni;
      29:VyberPrefFiltry(seznam_asciifiltru,seznam_vidiasciifiltru);
      31:Napoveda;
      32:OtevriInfoTXT;
      33:Informace_o_pameti;
      41:Do_UTF8;
      42:Z_UTF8;
      43:ZafixujNalamaniRadek;
      44:Hledej;
      45:OpakujHledani;
      46:Nahrad;
      47:MapaZnaku;
      48:ASCIIkonverze;
      end;
   end;
if ed<>nil then
   begin
   ed^.stav:=_aktivni;
   ed^.xm:=-mouse.last_px;
   ed^.ym:=-mouse.last_py;
   ed^.zobraz;
   end;
end;

Procedure ObrazekNaCelouObrazovku;
var v,fs:virtualwindow;
    _nx,_ny:real;
    nx,ny:longint;
    nb:boolean;
    r:real;
begin
r:=vga.breite/ob^.zdroj.breite;
_ny:=ob^.zdroj.hoehe*r;
ny:=round(_ny);
if ny>vga.hoehe then
   begin
   r:=vga.hoehe/ob^.zdroj.hoehe;
   _ny:=ob^.zdroj.hoehe*r;
   ny:=round(_ny);
   end;
_nx:=ob^.zdroj.breite*r;
nx:=round(_nx);

if obrazovy_filtr=1 then fs:=ScaleSprite(ob^.zdroj,nx,ny)
   else fs:=SmoothScaleSprite(ob^.zdroj,nx,ny,Tresizefilter(obrazovy_filtr-2));

Init_VW(v,vga.breite,vga.hoehe,false);
Mousehide;

Flip_VW(vga,v);
Clr(vga,0);
PutSprite(vga,fs,vga.breite div 2-fs.breite div 2,vga.hoehe div 2-fs.hoehe div 2);
MouseShow;
while xKeypressed do xReadkey;
Cekej;
while xKeypressed do xReadkey;
MouseRel;
MouseHide;
Flip_VW(v,vga);
MouseShow;
Kill_VW(fs);
Kill_VW(v);
end;

Function RotujDoprava:virtualwindow;
begin
RotujDoprava:=Rotate90p(ob^.zdroj);
end;

Function RotujDoleva:virtualwindow;
begin
RotujDoleva:=Rotate90m(ob^.zdroj);
end;

Function PrehniHorizontalne:virtualwindow;
begin
PrehniHorizontalne:=FlipHorz(ob^.zdroj);
end;

Function PrehniVertikalne:virtualwindow;
begin
PrehniVertikalne:=FlipVert(ob^.zdroj);
end;

Procedure ZmenObrazek(vw:virtualwindow);
var v:PEdob;
    p:PVaznik;
begin
p:=edvaz^.dalsi;
while p<>nil do
   begin
   v:=p^.vazba;
   if v^.ob=ob then
      begin
      Kill_VW(ob^.zdroj);
      Dispose(ob,Done);
      v^.ob:=New(PVWOkno,Init(_ex,_ey,_xr,_yr,vw,true,true));
      p^.vazba:=v;
      ob:=v^.ob;
      Exit;
      end;
   p:=p^.dalsi;
   end;
beep;
{Chyba, sem by se program nemel nikdy dostat.}
end;

Function SmazRadku:boolean;
begin
if ed=nil then Exit;
ed^.SmazRadku;
ed^.Zobraz;
end;

Function SmazZacatekRadky:boolean;
begin
if ed=nil then Exit;
ed^.SmazZacatekRadky;
ed^.Zobraz;
end;

Function SmazKonecRadky:boolean;
begin
if ed=nil then Exit;
ed^.SmazKonecRadky;
ed^.Zobraz;
end;

Function SmazSlovo:boolean;
begin
if ed=nil then Exit;
ed^.SmazSlovo;
ed^.Zobraz;
end;

Procedure Pust_a(b:boolean); {parametrem bude funkce, ktera se timto zavola}
var a:byte;
    znovu:boolean;
begin
{a:=mimoradny_kod;
repeat xKeyPressed until mimoradny_kod<>a;}
repeat
znovu:=false;
for a:=0 to 160 do
    if vsechny_klavesy[a]=true then znovu:=true;
until znovu=false;
end;

Function ZkontrolujNumerickou(o,kk:word):word;
begin
if Je_NumLock then Exit(o)
   else case o of
   KEY_NUM_7:o:=xHome;
   KEY_NUM_8:o:=xHSipka;
   KEY_NUM_9:o:=xPgUp;
   KEY_NUM_4:o:=xLSipka;
   KEY_NUM_5:o:=0;
   KEY_NUM_6:o:=xPSipka;
   KEY_NUM_1:o:=xEndk;
   KEY_NUM_2:o:=xDSipka;
   KEY_NUM_3:o:=xPgDn;
   KEY_NUM_0:o:=0;
   KEY_NUM_COMMA:o:=xIns;
   end;
ZkontrolujNumerickou:=o;
end;

Function MyEdProc(o:word):word;
var a,a2:longint;
    u,caps,zmc,dal:boolean;
    oo:longint;
    kl,km,kk:word;
    sf:string;
begin
sf:=FN_DEFAULT;
Nastavfont(fn_syst_font);
oo:=o;
o:=0;
dal:=not (jsem_v_hlavnim_okne);
if jsem_v_hlavnim_okne then
   begin
   if oo=xF10 then AktivaceMenu(0) else
   if oo=xESC then UkonciProgram else
   if oo=xF1 then NovySoubor else
   if oo=xF2 then UlozSoubor('') else
   if oo=xF3 then OtevriSoubor('') else
   if oo=xAltF3 then zadost_o_zavreni:=-1 else
   if oo=xAltF1 then zadost_o_otevreni:=EXEdir+'info.txt' else
   if oo=CTRL_ALT_NAHORU then Pust_a(SmazRadku) else
   if oo=CTRL_ALT_DOLEVA then Pust_a(SmazZacatekRadky) else
   if oo=CTRL_ALT_DOPRAVA then Pust_a(SmazKonecRadky) else
   if oo=CTRL_ALT_DOLU then Pust_a(SmazSlovo) else
   if oo=ALT_SHIFT then ZmenRozlozeniKlavesnice else
   if (vsechny_klavesy[KEY_CTRL]) and (vsechny_klavesy[KEY_F]) then Hledej else
   if (vsechny_klavesy[KEY_CTRL]) and (vsechny_klavesy[KEY_S]) then OpakujHledani else
   if (vsechny_klavesy[KEY_CTRL]) and (vsechny_klavesy[KEY_H]) then Nahrad else
   if (oo=xEnter) and (ob<>nil) then ObrazekNaCelouObrazovku else dal:=true;
   end;

if dal then
   begin
   {JE STISKNUTO COKOLIV JINEHO}
   o:=oo;
   if ed=nil then u:=false else u:=ed^.unicode;
   if aktualni_klavesnice^.soubor<>'' then
      begin
      kl:=kl_kod;
      km:=kl;
      kk:=kl;
      if je_capslock then
         begin
         zmc:=true;
         if km<1000 then      {jak by tato klavesa vypadala s CapsLockem?}
            inc(km,1000) else
            dec(km,1000);
         end else zmc:=false;

      kl:=prefix+kl;
      km:=prefix+km;
      caps:=false;
      if prefix<>0 then
         prefix:=prefix;
      prefix:=0;
      a2:=0;
      a:=0;

      {---Pro testovani kodu klaves---}
      {bar(vga,400,0,500,20,64000);
      print_fn(410,18,mystr(km),l_f);}

      repeat
      inc(a);
          if aktualni_klavesnice^.mapa^[a].p=km then
             if caps then Break else a2:=a;

          if aktualni_klavesnice^.mapa^[a].p=kl then
             if zmc=false then Break  {neni zmacky CapsLock - fajn}
                else     {CapsLock je zmackly}
                if aktualni_klavesnice^.mapa^[a].c=false
                   then Break         {tato klavesa se na CapsLock neohlizi}
                   else
                   if a2=0 then    {Byla tu uz CapsLockova varianta?}
                      caps:=true      {ne? Tak od ted ji cilene hledame}
                      else begin
                      a:=a2;          {jo? A kde byla?}
                      Break;
                      end;
      until a=MAX_KLAVES;
      if a<MAX_KLAVES then
         begin
         if u then oo:=aktualni_klavesnice^.mapa^[a].u
              else oo:=aktualni_klavesnice^.mapa^[a].a;
         if oo<0 then begin o:=0;prefix:=-oo;end
                  else begin o:=oo;prefix:=0;end;
         end
         else o:=ZkontrolujNumerickou(o,kk);
      end;
   end;
{NastavFont(sf);}
MyEdProc:=o;
end;

Procedure HlidejKlavesnici;
var o:word;
begin
if xKeyPressed then
   begin
   o:=xReadKey;
   MyEdProc(o);
   end;
end;

Procedure MyEdZobrProc;
var x,l:longint;
    s,t:string;
    w:word;
begin
x:=vga.breite-100;
Bar(vga,x,VYSKA_HL_MENU+1,vga.breite-2,VYSKA_HL_MENU+16,mvbarva);
w:=FN_color;
FN_color:=65535;
s:=mystr(ed^.pozice.y)+':'+mystr(ed^.pozice.vx);
t:=fn_default;
NastavFont(fn_font_vga16);
l:=Sirka_FN(s,l_f);

{l:=l+150;
s:=s+' -> '+mystr(kl_kod);}

Print_FN(vga.breiteminus1-l-2,VYSKA_HL_MENU+16,s,l_f);
Nastavfont(t);
FN_color:=w;
end;

Procedure NapisKodZnaku(x1,y1,x2,y2:longint;s:string;z:word;f:fn;si,vy:longint);
var ofn:string;
    ofc:word;
    nx,ny:longint;
    v:virtualwindow;
begin
Init_VW(v,x2-x1+1,y2-y1+1,false);
MouseHide;
GetSprite(vga,v,x1,y1);
Rectangle(vga,x1,y1,x2,y2,RGB2word(14,33,7));
Bar(vga,x1+1,y1+1,x2-1,y2-1,61184);
nx:=(x2+x1) div 2 - si div 2;
ny:=y1+f^.so+2;
ofc:=FN_color;
FN_color:=0;
fn_ignore:=false;
if s='' then
   begin
   LineClipped(vga,x1+1,y1+1,x2-1,y2-1,47104);
   LineClipped(vga,x2-1,y1+1,x1+1,y2-1,47104);
   end
   else begin
   if s='<<' then s:='<';
   if s='>>' then s:='>';
   Print_FN(nx,ny,s,f);
   Print_FN(x1+2,y2-16-2,mystr(z),l_f);
   Print_FN(x1+2,y2-2,dec2hex(z)+'h',l_f);
   end;
fn_ignore:=true;
FN_color:=ofc;
MouseShow;
mouserel;bufferoff;
repeat
if xKeyPressed then begin xReadkey;Break;end;
until mouse.b<>0;
repeat until mouse.b<2;
MouseHide;
PutSprite(vga,v,x1,y1);
MouseShow;
end;

Procedure MyEdPmysProc(e:PMojeEdipole);
var SIRKA,VYSKA:byte;
    w:word;
    v:PEdRadek;
    pn:byte;
    p:pchar;
    x,si,vy,mx,my:longint;
    s:string;
    f:fn;
begin
SIRKA:=65;VYSKA:=50;
v:=pedradek(e^.pozice.r^.vazba);
p:=v^.p;
x:=e^.pozice.x;
if x<v^.spp then
   if e^.unicode=false then
      begin
      w:=byte(p[x-1]);
      s:=p[x-1];
      end
      else begin
      w:=UTF82word(v^.p,v^.spp-1,x,pn);
      s:=v^.VratString(x,pn);
      end
   else s:='';
if s='<' then s:='<<';
if s='>' then s:='>>';
mx:=mouse.x;
my:=mouse.y;
si:=Sirka_FN(s,l_f);
vy:=RychlaVyskaRadky(s);
if si>SIRKA-10 then SIRKA:=si+10;
if vy>VYSKA-38 then VYSKA:=vy+38;
OpravVycuhovani(mx,my,SIRKA,VYSKA);
f:=String2FN(e^.hlavni_font);
NapisKodZnaku(mx,my,mx+SIRKA-1,my+VYSKA-1,s,w,f,si,vy);
end;

Function NastartujEditacniPole(obrazek:boolean):PMojeEdipole;
var e:PEdob;
begin
e:=New(PEdob,Init(obrazek));
edvaz^.InitNext(e);
NastartujEditacniPole:=e^.ed;
VykresliDolniListu;
end;

Constructor Edob.Init(obrazek:boolean);
var e:PMojeEdipole;
    i:PTlacitko;
    hv:boolean;
    p:pointer;
begin
if obrazek then self.ed:=nil
   else begin
   e:=New(PMojeEdipole,Init(_ex,_ey,_xr,_yr,true));
   self.ed:=e;
   end;
hv:=hned_vykresluj;
hned_vykresluj:=false;
i:=New(PTlacitko,Init(0,0,'','',0,0));
hned_vykresluj:=hv;
self.ob:=nil;
end;

Destructor Edob.Done;
begin
if self.ed=nil then
               begin
               Kill_VW(ob^.zdroj);
               Dispose(ob,Done);
               end
               else Dispose(ed,Done);
end;

Procedure lis_vybrani_z_listy(i:longint;p:Plista);
var v:Pedob;
    q,r:PVaznik;
    h:PTlacitko;
begin
q:=p^.objektiky^.SearchRecord(i);
h:=q^.vazba;
if h^.hodnota=_ExtraAkce then
   begin
   zadost_o_zavreni:=i;
   Exit;
   end;
r:=edvaz^.SearchRecord(i);
v:=r^.vazba;
if v^.ed=nil then
   begin
   p^.barva_stiskleho:=21;
   tvbarva:=767;
   end
   else p^.barva_stiskleho:=16936;
end;

Function lis_text_s_napovedou(p:pointer):string;
var v:PEdob;
    s,cs,jm,ex:string;
    i:longint;
begin
v:=p;
if v^.ed=nil then s:=v^.ob^.info1 else s:=v^.ed^.info1;
if s=hlla('bezejmenny') then
   begin
   lis_text_s_napovedou:=hlla('bezejmenny_soubor');
   end
   else begin
   FSplit(s,cs,jm,ex);
   jm:='<POZADI=59393>'+jm+ex+'<POZADI=->'#13#10;
   i:=Sirka_FN(jm,l_f);
   if i<250 then i:=250;
   jm:='<MIN_NAP_SIR='+MyStr(i)+'>'+jm;
   s:=jm+s;
   lis_text_s_napovedou:=s;
   end;
end;

Function PrepniOkno(p:PVaznik):byte;
var v:PEdob;
    s:string;
begin
v:=p^.vazba;
ed:=v^.ed;
if ed=nil then    {je to obrazek nebo text?}
   begin
   ob:=v^.ob;     {obrazek}
   s:=ob^.info1;
   ob^.zobraz;
   end
   else begin
   ob:=nil;
   Clr(ed^.virt^,ed^.pozadi);
   ed^.Zobraz;
   end;
VykresliDolniListu;
end;

Procedure ZkontrolujListu;
var i:longint;
    p:PVaznik;
begin
listicka.kontrola;
if listicka.kliknuto then  {bylo prepnuto}
   begin
   p:=edvaz^.SearchRecord(listicka.zadane);
   PrepniOkno(p);
   end;
end;

Function Najdi_ED_ve_vazniku:PVaznik;
var p:Pvaznik;
    v:PEdob;
begin
p:=edvaz^.dalsi;
while p<>nil do
   begin
   v:=p^.vazba;
   if ed<>nil then
      if v^.ed=ed then Exit(p) else
      else if v^.ob=ob then Exit(p);
   p:=p^.dalsi;
   end;
Najdi_ED_ve_vazniku:=nil;
end;

Function ZavriOkno(p:PVaznik):byte;
var v:Pedob;
    q:Pvaznik;
    b:byte;
    i,j,k:longint;
begin
v:=p^.vazba;
if ed<>nil then
   if ed^.byla_zmena then
      begin
      b:=polohovane_anonezrusokno(NA_STRED,NA_STRED,hlla('opravdu_zavrit'));
      if b=2 then Exit else
      if b=1 then UlozSoubor(ed^.info1);
      end;
i:=p^.Kolik_prede_mnou;
j:=listicka.zadane;
if i=j then
   if p^.predchozi^.predchozi=nil then q:=p^.dalsi else q:=p^.predchozi
   else q:=Najdi_ED_ve_vazniku;
Dispose(v,Done);
Dispose(p,Done);
if q<>nil then
   begin
   k:=q^.Kolik_prede_mnou;
   listicka.zadane:=k;
   end;
listicka.prvni:=1;
listicka.NatahniPrvky(edvaz);
listicka.SrovnejListu;
listicka.zobraz;
if q<>nil then
   begin
   v:=q^.vazba;
   ed:=v^.ed;
   if ed=nil then {je to obrazek nebo text?}
      begin
      ob:=v^.ob;
      ob^.Zobraz;
      end
      else begin
      ob:=nil;
      ed^.Zobraz;
      end;
   VykresliDolniListu;
   end
   else begin
   ed:=nil;
   ob:=nil;
   VykresliPracoviste;
   end;
end;

Procedure ZavriOkno_z_menu;
var p:PVaznik;
    v:PEdob;
begin
if (ed=nil) and (ob=nil) then Exit;

if zadost_o_zavreni=-1 then
   begin
   zadost_o_zavreni:=0;
   p:=Najdi_ED_ve_vazniku;
   ZavriOkno(p);
   end
   else begin
   p:=EdVaz^.SearchRecord(zadost_o_zavreni);
   ZavriOkno(p);
   zadost_o_zavreni:=0;
   end;
end;

Procedure PohlidejZatrzitka;
var b:boolean;
begin
Klin_pohlidej;
if ob<>nil then        {mame otevreny obrazek?}
   begin
   ob_zoom.kontrola;
   ob_rp.kontrola;
   ob_rm.kontrola;
   ob_fh.kontrola;
   ob_fv.kontrola;
   if ob_zoom.klik=1 then ObrazekNaCelouObrazovku;

   if ob_rp.klik=1 then ZmenObrazek(RotujDoprava);
   if ob_rm.klik=1 then ZmenObrazek(RotujDoleva);
   if ob_fh.klik=1 then ZmenObrazek(PrehniHorizontalne);
   if ob_fv.klik=1 then ZmenObrazek(PrehniVertikalne);
   Exit;
   end;

if ed=nil then Exit;   {otevreno neni vubec nic?}
b:=false;
za_un.kontrola;
za_za.kontrola;
if za_un.bylo_klepnuto then
   begin
   ed^.unicode:=za_un.hodnota;
   if za_un.hodnota then
      ed^.ZmenFont(unicode_font) else ed^.ZmenFont(non_unicode_font);
   b:=true;
   end;
if za_za.bylo_klepnuto then
   begin
   if ed^.zalamuj then ed^.PosouvaciRezim else ed^.ZalamovaciRezim;
   b:=true;
   end;
if B then ed^.Zobraz;
end;

Procedure PootvirejSoubory;
var i:longint;
    s:string;
begin
repeat
   i:=Pos(#13#10,zadost_o_otevreni);
   if i=0 then
      begin
      s:=FExpand(zadost_o_otevreni);
      OtevriSoubor(s);
      end
      else begin
      s:=Copy(zadost_o_otevreni,1,i-1);
      s:=FExpand(s);
      OtevriSoubor(s);
      delete(zadost_o_otevreni,1,i);
      end;
until i=0;
end;

Procedure OtaznikNaPrikRadce;
begin
Kill_mouse;
Kill_graph;
writeln(hlla('parametr_otaznik'));
Halt(0);
end;

Procedure Pomlcka(s:string);
begin
delete(s,1,1);
if s='?' then OtaznikNaPrikRadce;
{if s='U' then unicode_startup:=true;}
end;

Procedure Parser;
var a,b:byte;
    s,soubor:string;
begin
soubor:='';
b:=LFNParamCount(CommandLine);
for a:=1 to b do
  begin
  s:=Convert_Up(LFNParamStr(CommandLine,a));
  case s[1] of
    '/','-':Pomlcka(s);
  else if ExistFile(s) then
          if zadost_o_otevreni='' then
             zadost_o_otevreni:=s else
             zadost_o_otevreni:=zadost_o_otevreni+#13#10+s;
  end;
  end;
end;

Procedure ZachytNedostatkuPameti;
begin
Bar(vga,vga.breite div 2-200,vga.hoehe div 2-100,vga.breite div 2-200,vga.hoehe div 2-100,0);
Print_FN(vga.breite div 2-100,vga.hoehe div 2,'Cannot allocate memory!',l_f);
debug;
UkonciProgram;
end;

Procedure ZkontrolujKonfigurace;
var p:PVaznik;
    v:PString;
    i:longint;
    ok:Pokno;
    okt:PTlacitko;
begin
p:=chybejici_konfigurace^.dalsi;
if p=nil then Exit;
i:=0;
i:=chybejici_konfigurace^.PocetPrvku*16;
Okokno_mustr(ok,250,i+60,hlla('info'),hlla('pridani_bcfg'),okt);
FN_color:=51200;
SetBasicLine(ok^.y+ok^.volne_y+16);
while p<>nil do
   begin
   v:=p^.vazba;
   Print_FN(ok^.x+5,AUTO_LINE,v^,l_f);
   p:=p^.dalsi;
   end;
SetBasicline(0);
FN_color:=0;
repeat
okt^.kontrola;
if xKeyPressed then xReadKey;
if xLastKey in [xESC,xEnter] then Break;
until okt^.klik=1;
Dispose(okt,Done);
Dispose(ok,Done);
end;

Procedure TestVirtualniPameti;
var d:dpmiinfoblock;
    s:string;
    e:PEdRadek;
begin

if check_swap<>1 then Exit;
GetDPMIinfo(d);
if d.virtualizace=false then
   begin
   e:=New(PEdRadek,Init);
   e^.VlozS(hlla('neniswap'),1);
   if (d.vendor_version_major=0) and (d.vendor_version_minor=0)
      then e^.VlozS(#13#10#13#10+hlla('dpmineznamy'),e^.spp)
      else e^.VlozS(#13#10#13#10'<PODTRH=+>'+d.vendor+' '+mystr(d.vendor_version_major)+'.'+mystr(d.vendor_version_major)+'<PODTRH=->',e^.spp);
   e^.VlozS(#13#10#13#10+hlla('kaslinaswap'),e^.spp);
   OKokno(hlla('varovani'),e^.p);
   Dispose(e,Done);
   end;
end;



{****************************************************************************}
{****************************************************************************}

var i:longint;
    p:pointer;
    b:byte;
begin
OldExitProc:=ExitProc;
ExitProc:=@MyExitProc;

dbg:=false;
chybejici_konfigurace:=New(PVaznik,Init(nil,nil));
b:=NactiKonfiguraci;
Parser;               {zpracovani parametru prikazoveho radku}

ZapniGrafiku;
_zachyt_nedostatku_pameti:=@ZachytNedostatkuPameti;
FN_color:=0;
PracVW:=nil;
ZavedSystemovyFont;
utf8_tbl:=@moje_utf8_tbl;
edvaz:=New(PVaznik,Init(nil,nil));
ed:=nil;
ob:=nil;
ZalozZatrzitko;
DefiniceMenu;
VykresliPracoviste;

case b of
   BLOCEK_CFG_OK:ZkontrolujKonfigurace;
   BLOCEK_CFG_CHYBI:OKokno(hlla('info'),hlla('chybi_bcfg'));
   BLOCEK_CFG_NESPRAVNY:OKokno(hlla('info'),hlla('chybny_bcfg'));
end;
SmazVaznikPStringu(chybejici_konfigurace);

{TextoveOkno(NA_STRED,NA_STRED,400,300,'pokus',NajdiClanek(hlasky,'text_napovedy'));}


{Opicarna, zby mi to vzal i FPC 2.0.2}
p:=@xReadKey_obsluha;xReadKey_Doplnek:=_xReadkey_Doplnek(p);
p:=@xKeyPressed_obsluha_AltShift;xKeyPressed_Doplnek:=_xKeyPressed_Doplnek(p);
TestVirtualniPameti;
{------------------------------------}
ZapniObsluhuKlavesnice(KL_S_BIOSEM);
SpocitejZachytneBody;
Init_VW(GlobalVirt,_xr-_SirPos,_yr,false);
repeat
if ob<>nil then
   begin
   ob^.kontrola;                  {Co kdyz nezobrazujeme text, ale obrazek?}
   end;
if ed<>nil then
   begin
   if ed^.stav<>_aktivni then
      begin
      ed^.stav:=_aktivni;
      ed^.xm:=-mouse.last_px;
      ed^.ym:=-mouse.last_py;
      end;
   ed^.kontrola;                  {o klavesnici se normalne stara otevrene okno}
   end else
   HlidejKlavesnici;              {kdyz ale zadne neexistuje...}
i:=vb^.kontrola;
if i<>0 then AktivaceMenu(i);
if zadost_o_zavreni<>0 then ZavriOkno_z_menu;
if zadost_o_otevreni<>'' then
   begin
   PootvirejSoubory;
   zadost_o_otevreni:='';
   end;

ZkontrolujListu;
PohlidejZatrzitka;
until 1=2;

Dispose(ed,Done);
Kill_Mouse;
Kill_Graph;
end.
