unit Clanky;
{$I defines.inc}
{$R-}
{$Q-}
{$S-}
interface
uses Vaznik;

type
     pclanek = ^tclanek;
     tclanek = record
     pocet_radek:longint;
     nadpis:string[32];
     text:pchar;
     end;

     tdpole = array[0..0] of pointer;
     pdpole = ^tdpole;


Function Nacti_Data(co:string):pdpole;
Function hlla(s:string):string;
Function hllp(hl:pdpole;s:string):pchar;
Function hllp(s:string):pchar;

var vaznik_s_hlaskami:pdpole;
    otazniky:string[2];
    clKonecRadky:string[5];

implementation
uses FnFont2,Lacrt,tedradky;

const CL_NENALEZENO = '???';

Function Trideni_S(p,q:pointer):boolean;
var v1,v2:pclanek;
begin
v1:=p;v2:=q;
Trideni_S:=v1^.nadpis<v2^.nadpis;
end;

Function DoPole(p:PVaznik):pdpole;
var q:PVaznik;
    d:pdpole;
    i,j:longint;
begin
i:=p^.PocetPrvku;
GetMem(d,(i+1)*4);
d^[0]:=pointer(i);
j:=1;
q:=p^.dalsi;
while q<>nil do
   begin
   d^[j]:=q^.vazba;
   q:=q^.dalsi;
   inc(j);
   end;
DoPole:=d;
end;

Function Nacti_Data(co:string):pdpole;
var f:text;
    s,t:string;
    p,q:PVaznik;
    v:pclanek;
    e:PEdRadek;
    _compproc:pointer;
begin
Assign(f,co);
Reset(f);
p:=New(PVaznik,Init(nil,nil));
q:=p;
e:=nil;
while not Eof(f) do
   begin
   readln(f,s);
      if s[1]='#' then
         begin
         s:=skipallspaces(s);
         if e<>nil then
            begin
            v^.text:=e^.p;      {nutne - pri e^.VlozS se muze menit e^.p}
            e^.p:=nil;
            Dispose(e,Done);
            end;
         delete(s,1,1);
         s:=Convert_down(s);
         new(v);
         e:=New(PEdRadek,Init);
         q:=q^.InitNext(v);
         v^.nadpis:=s;
         v^.text:=e^.p;
         v^.pocet_radek:=0;
         end
         else begin
         if s<>'' then s:=skipbegspaces(skipendspaces(s));
         if s[1]=#39 then
            begin
            delete(s,Length(s),1);
            delete(s,1,1);
            end;
         inc(v^.pocet_radek);
         if v^.pocet_radek<>1 then e^.VlozS(#13#10,e^.spp);
         e^.VlozS(s,e^.spp);

         end;
   end;
v^.text:=e^.p;      {nutne - pri e^.VlozS se muze menit e^.p}
e^.p:=nil;
Dispose(e,Done);
Close(f);

_compproc:=procSortComp;
procSortComp:=@Trideni_S;
p^.Setrid;
move(_compproc,procSortComp,4);
Nacti_Data:=DoPole(p);
Vaznik_Done_All(p);
end;

Function hllp(hl:pdpole;s:string):pchar;
var i,j,a:longint;
    v:pclanek;
begin
j:=longint(hl^[0]);
i:=1;
s:=Convert_down(s);
repeat
a:=(j+i) div 2;
v:=hl^[a];
if s<v^.nadpis then j:=a-1 else
if s>v^.nadpis then i:=a+1 else
if s=v^.nadpis then Exit(v^.text);
until j-i<0;
hllp:=CL_NENALEZENO;
end;

Function hlla(s:string):string;
var p:pchar;
begin
p:=hllp(vaznik_s_hlaskami,s);
hlla:=p;
end;

Function hllp(s:string):pchar;
begin
hllp:=hllp(vaznik_s_hlaskami,s);
end;

end.
